require '_h2ph_pre.ph';

unless(defined(&__ASM_MIPS_BOOTINFO_H)) {
    eval 'sub __ASM_MIPS_BOOTINFO_H () {1;}' unless defined(&__ASM_MIPS_BOOTINFO_H);
    require 'linux/config.ph';
    eval 'sub MACH_GROUP_UNKNOWN () {0;}' unless defined(&MACH_GROUP_UNKNOWN);
    eval 'sub MACH_GROUP_JAZZ () {1;}' unless defined(&MACH_GROUP_JAZZ);
    eval 'sub MACH_GROUP_DEC () {2;}' unless defined(&MACH_GROUP_DEC);
    eval 'sub MACH_GROUP_ARC () {3;}' unless defined(&MACH_GROUP_ARC);
    eval 'sub MACH_GROUP_SNI_RM () {4;}' unless defined(&MACH_GROUP_SNI_RM);
    eval 'sub MACH_GROUP_ACN () {5;}' unless defined(&MACH_GROUP_ACN);
    eval 'sub MACH_GROUP_SGI () {6;}' unless defined(&MACH_GROUP_SGI);
    eval 'sub MACH_GROUP_COBALT () {7;}' unless defined(&MACH_GROUP_COBALT);
    eval 'sub GROUP_NAMES () {{ "unknown", "Jazz", "Digital", "ARC", "SNI", "ACN", "SGI", "Cobalt" };}' unless defined(&GROUP_NAMES);
    eval 'sub MACH_UNKNOWN () {0;}' unless defined(&MACH_UNKNOWN);
    eval 'sub GROUP_UNKNOWN_NAMES () {{ "unknown" };}' unless defined(&GROUP_UNKNOWN_NAMES);
    eval 'sub MACH_ACER_PICA_61 () {0;}' unless defined(&MACH_ACER_PICA_61);
    eval 'sub MACH_MIPS_MAGNUM_4000 () {1;}' unless defined(&MACH_MIPS_MAGNUM_4000);
    eval 'sub MACH_OLIVETTI_M700 () {2;}' unless defined(&MACH_OLIVETTI_M700);
    eval 'sub GROUP_JAZZ_NAMES () {{ "Acer PICA 61", "Mips Magnum 4000", "Olivetti M700" };}' unless defined(&GROUP_JAZZ_NAMES);
    eval 'sub MACH_DSUNKNOWN () {0;}' unless defined(&MACH_DSUNKNOWN);
    eval 'sub MACH_DS23100 () {1;}' unless defined(&MACH_DS23100);
    eval 'sub MACH_DS5100 () {2;}' unless defined(&MACH_DS5100);
    eval 'sub MACH_DS5000_200 () {3;}' unless defined(&MACH_DS5000_200);
    eval 'sub MACH_DS5000_1XX () {4;}' unless defined(&MACH_DS5000_1XX);
    eval 'sub MACH_DS5000_XX () {5;}' unless defined(&MACH_DS5000_XX);
    eval 'sub MACH_DS5000_2X0 () {6;}' unless defined(&MACH_DS5000_2X0);
    eval 'sub MACH_DS5400 () {7;}' unless defined(&MACH_DS5400);
    eval 'sub MACH_DS5500 () {8;}' unless defined(&MACH_DS5500);
    eval 'sub MACH_DS5800 () {9;}' unless defined(&MACH_DS5800);
    eval 'sub GROUP_DEC_NAMES () {{ "unknown", "DECstation 2100/3100", "DECstation 5100", "DECstation 5000/200", "DECstation 5000/1xx", "Personal DECstation 5000/xx", "DECstation 5000/2x0", "DECstation 5400", "DECstation 5500", "DECstation 5800" };}' unless defined(&GROUP_DEC_NAMES);
    eval 'sub MACH_DESKSTATION_RPC44 () {0;}' unless defined(&MACH_DESKSTATION_RPC44);
    eval 'sub MACH_DESKSTATION_TYNE () {1;}' unless defined(&MACH_DESKSTATION_TYNE);
    eval 'sub GROUP_ARC_NAMES () {{ "Deskstation rPC44", "Deskstation Tyne" };}' unless defined(&GROUP_ARC_NAMES);
    eval 'sub MACH_SNI_RM200_PCI () {0;}' unless defined(&MACH_SNI_RM200_PCI);
    eval 'sub GROUP_SNI_RM_NAMES () {{ "RM200 PCI" };}' unless defined(&GROUP_SNI_RM_NAMES);
    eval 'sub MACH_ACN_MIPS_BOARD () {0;}' unless defined(&MACH_ACN_MIPS_BOARD);
    eval 'sub GROUP_ACN_NAMES () {{ "ACN" };}' unless defined(&GROUP_ACN_NAMES);
    eval 'sub MACH_SGI_INDY () {0;}' unless defined(&MACH_SGI_INDY);
    eval 'sub GROUP_SGI_NAMES () {{ "Indy" };}' unless defined(&GROUP_SGI_NAMES);
    eval 'sub MACH_COBALT_27 () {0;}' unless defined(&MACH_COBALT_27);
    eval 'sub GROUP_COBALT_NAMES () {{ "Microserver 27" };}' unless defined(&GROUP_COBALT_NAMES);
    eval 'sub CPU_UNKNOWN () {0;}' unless defined(&CPU_UNKNOWN);
    eval 'sub CPU_R2000 () {1;}' unless defined(&CPU_R2000);
    eval 'sub CPU_R3000 () {2;}' unless defined(&CPU_R3000);
    eval 'sub CPU_R3000A () {3;}' unless defined(&CPU_R3000A);
    eval 'sub CPU_R3041 () {4;}' unless defined(&CPU_R3041);
    eval 'sub CPU_R3051 () {5;}' unless defined(&CPU_R3051);
    eval 'sub CPU_R3052 () {6;}' unless defined(&CPU_R3052);
    eval 'sub CPU_R3081 () {7;}' unless defined(&CPU_R3081);
    eval 'sub CPU_R3081E () {8;}' unless defined(&CPU_R3081E);
    eval 'sub CPU_R4000PC () {9;}' unless defined(&CPU_R4000PC);
    eval 'sub CPU_R4000SC () {10;}' unless defined(&CPU_R4000SC);
    eval 'sub CPU_R4000MC () {11;}' unless defined(&CPU_R4000MC);
    eval 'sub CPU_R4200 () {12;}' unless defined(&CPU_R4200);
    eval 'sub CPU_R4400PC () {13;}' unless defined(&CPU_R4400PC);
    eval 'sub CPU_R4400SC () {14;}' unless defined(&CPU_R4400SC);
    eval 'sub CPU_R4400MC () {15;}' unless defined(&CPU_R4400MC);
    eval 'sub CPU_R4600 () {16;}' unless defined(&CPU_R4600);
    eval 'sub CPU_R6000 () {17;}' unless defined(&CPU_R6000);
    eval 'sub CPU_R6000A () {18;}' unless defined(&CPU_R6000A);
    eval 'sub CPU_R8000 () {19;}' unless defined(&CPU_R8000);
    eval 'sub CPU_R10000 () {20;}' unless defined(&CPU_R10000);
    eval 'sub CPU_R4300 () {21;}' unless defined(&CPU_R4300);
    eval 'sub CPU_R4650 () {22;}' unless defined(&CPU_R4650);
    eval 'sub CPU_R4700 () {23;}' unless defined(&CPU_R4700);
    eval 'sub CPU_R5000 () {24;}' unless defined(&CPU_R5000);
    eval 'sub CPU_R5000A () {25;}' unless defined(&CPU_R5000A);
    eval 'sub CPU_R4640 () {26;}' unless defined(&CPU_R4640);
    eval 'sub CPU_NEVADA () {27;}' unless defined(&CPU_NEVADA);
    eval 'sub CPU_LAST () {27;}' unless defined(&CPU_LAST);
    eval 'sub CPU_NAMES () {{ "unknown", "R2000", "R3000", "R3000A", "R3041", "R3051", "R3052", "R3081", "R3081E", "R4000PC", "R4000SC", "R4000MC", "R4200", "R4400PC", "R4400SC", "R4400MC", "R4600", "R6000", "R6000A", "R8000", "R10000", "R4300", "R4650", "R4700", "R5000", "R5000A", "R4640", "Nevada" };}' unless defined(&CPU_NAMES);
    eval 'sub CL_SIZE () {(80);}' unless defined(&CL_SIZE);
    unless(defined(&_LANGUAGE_ASSEMBLY)) {
	if(defined(&CONFIG_SGI)) {
	    eval 'sub DEFAULT_SCREEN_INFO () {{0, 0, 0, 0, 0, 160, 0, 0, 0, 64, 0, 16};}' unless defined(&DEFAULT_SCREEN_INFO);
	    eval 'sub DEFAULT_DRIVE_INFO () {{ {0,}};}' unless defined(&DEFAULT_DRIVE_INFO);
	} else {
	    eval 'sub DEFAULT_SCREEN_INFO () {{0, 0, 0, 52, 3, 80, 4626, 3, 9, 50, 0x22, 16};}' unless defined(&DEFAULT_SCREEN_INFO);
	}
	eval 'sub DEFAULT_DRIVE_INFO () {{ {0,}};}' unless defined(&DEFAULT_DRIVE_INFO);
    }
}
1;
