require '_h2ph_pre.ph';

unless(defined(&__ASM_MIPS_COBALT_H)) {
    eval 'sub __ASM_MIPS_COBALT_H () {1;}' unless defined(&__ASM_MIPS_COBALT_H);
    eval 'sub COBALT_LOCAL_IO_SPACE () {0xa0000000;}' unless defined(&COBALT_LOCAL_IO_SPACE);
    eval 'sub COBALT_IE_PCI () {(1<< 0);}' unless defined(&COBALT_IE_PCI);
    eval 'sub COBALT_IE_FLOPPY () {(1<< 1);}' unless defined(&COBALT_IE_FLOPPY);
    eval 'sub COBALT_IE_KEYBOARD () {(1<< 2);}' unless defined(&COBALT_IE_KEYBOARD);
    eval 'sub COBALT_IE_SERIAL1 () {(1<< 3);}' unless defined(&COBALT_IE_SERIAL1);
    eval 'sub COBALT_IE_SERIAL2 () {(1<< 4);}' unless defined(&COBALT_IE_SERIAL2);
    eval 'sub COBALT_IE_PARALLEL () {(1<< 5);}' unless defined(&COBALT_IE_PARALLEL);
    eval 'sub COBALT_IE_GPIO () {(1<< 6);}' unless defined(&COBALT_IE_GPIO);
    eval 'sub COBALT_IE_RTC () {(1<< 7);}' unless defined(&COBALT_IE_RTC);
    eval 'sub COBALT_IE_ETHERNET () {(1<< 7);}' unless defined(&COBALT_IE_ETHERNET);
    eval 'sub COBALT_IE_SCSI () {(1<< 7);}' unless defined(&COBALT_IE_SCSI);
    eval 'sub COBALT_TIMER_IRQ () {0;}' unless defined(&COBALT_TIMER_IRQ);
    eval 'sub COBALT_KEYBOARD_IRQ () {1;}' unless defined(&COBALT_KEYBOARD_IRQ);
    eval 'sub COBALT_ETHERNET_IRQ () {13;}' unless defined(&COBALT_ETHERNET_IRQ);
    eval 'sub COBALT_SCC_IRQ () {4;}' unless defined(&COBALT_SCC_IRQ);
    eval 'sub COBALT_SERIAL2_IRQ () {4;}' unless defined(&COBALT_SERIAL2_IRQ);
    eval 'sub COBALT_PARALLEL_IRQ () {5;}' unless defined(&COBALT_PARALLEL_IRQ);
    eval 'sub COBALT_FLOPPY_IRQ () {6;}' unless defined(&COBALT_FLOPPY_IRQ);
    eval 'sub COBALT_SCSI_IRQ () {7;}' unless defined(&COBALT_SCSI_IRQ);
    unless(defined(&_LANGUAGE_ASSEMBLY)) {
    }
    eval 'sub VIA_DELAY () {
        eval q({ \'unsigned char ctr\';  &for ( &ctr=0; &ctr<1; &ctr++); });
    }' unless defined(&VIA_DELAY);
    eval 'sub VIA_PORT_WRITE {
        local($x,$y) = @_;
	    eval q({ *( (0xb0000000 | $x)) = $y;  &VIA_DELAY(); });
    }' unless defined(&VIA_PORT_WRITE);
    eval 'sub VIA_PORT_READ {
        local($x) = @_;
	    eval q((*( (0xb0000000 | ($x)))));
    }' unless defined(&VIA_PORT_READ);
    eval 'sub RESET_VIA_TIMER () {
        eval q( &asm(\\"sb\\\\t%1,0x70(%0)\\\\n\\\\t\\" \\"lb\\\\$0,0x71(%0)\\" : : \\"r\\" (0xb0000000), \\"i\\" (0x0c)););
    }' unless defined(&RESET_VIA_TIMER);
}
1;
