require '_h2ph_pre.ph';

unless(defined(&__ASM_MIPS_KEYBOARD_H)) {
    eval 'sub __ASM_MIPS_KEYBOARD_H () {1;}' unless defined(&__ASM_MIPS_KEYBOARD_H);
    if(defined(&__KERNEL__)) {
	require 'linux/config.ph';
	require 'linux/delay.ph';
	require 'linux/ioport.ph';
	require 'asm/bootinfo.ph';
	eval 'sub DISABLE_KBD_DURING_INTERRUPTS () {0;}' unless defined(&DISABLE_KBD_DURING_INTERRUPTS);
	eval 'sub kbd_setkeycode () { &pckbd_setkeycode;}' unless defined(&kbd_setkeycode);
	eval 'sub kbd_getkeycode () { &pckbd_getkeycode;}' unless defined(&kbd_getkeycode);
	eval 'sub kbd_translate () { &pckbd_translate;}' unless defined(&kbd_translate);
	eval 'sub kbd_unexpected_up () { &pckbd_unexpected_up;}' unless defined(&kbd_unexpected_up);
	eval 'sub kbd_leds () { &pckbd_leds;}' unless defined(&kbd_leds);
	eval 'sub kbd_init_hw () { &pckbd_init_hw;}' unless defined(&kbd_init_hw);
	eval 'sub kbd_sysrq_xlate () { &pckbd_sysrq_xlate;}' unless defined(&kbd_sysrq_xlate);
	eval 'sub SYSRQ_KEY () {0x54;}' unless defined(&SYSRQ_KEY);
	eval 'sub kbd_pause () {
	    eval q( &do { }  &while(0));
	}' unless defined(&kbd_pause);
	eval 'sub kbd_request_region () {
	    eval q( ($kbd_ops->{kbd_request_region})());
	}' unless defined(&kbd_request_region);
	eval 'sub kbd_request_irq {
	    local($handler) = @_;
    	    eval q( ($kbd_ops->{kbd_request_irq})($handler));
	}' unless defined(&kbd_request_irq);
	eval 'sub aux_request_irq {
	    local($hand, $dev_id) = @_;
    	    eval q( ($kbd_ops->{aux_request_irq})($hand));
	}' unless defined(&aux_request_irq);
	eval 'sub aux_free_irq {
	    local($dev_id) = @_;
    	    eval q( ($kbd_ops->{aux_free_irq})());
	}' unless defined(&aux_free_irq);
	eval 'sub kbd_read_input () {
	    eval q( ($kbd_ops->{kbd_read_input})());
	}' unless defined(&kbd_read_input);
	eval 'sub kbd_write_output {
	    local($val) = @_;
    	    eval q( ($kbd_ops->{kbd_write_output})($val));
	}' unless defined(&kbd_write_output);
	eval 'sub kbd_write_command {
	    local($val) = @_;
    	    eval q( ($kbd_ops->{kbd_write_command})($val));
	}' unless defined(&kbd_write_command);
	eval 'sub kbd_read_status () {
	    eval q( ($kbd_ops->{kbd_read_status})());
	}' unless defined(&kbd_read_status);
    }
}
1;
