require '_h2ph_pre.ph';

unless(defined(&__ASM_MIPS_MIPSREGS_H)) {
    eval 'sub __ASM_MIPS_MIPSREGS_H () {1;}' unless defined(&__ASM_MIPS_MIPSREGS_H);
    require 'linux/linkage.ph';
    unless(defined(&__STR)) {
	eval 'sub __STR {
	    local($x) = @_;
    	    eval q($x);
	}' unless defined(&__STR);
    }
    unless(defined(&STR)) {
	eval 'sub STR {
	    local($x) = @_;
    	    eval q( &__STR($x));
	}' unless defined(&STR);
    }
    eval 'sub CP0_INDEX () {$0;}' unless defined(&CP0_INDEX);
    eval 'sub CP0_RANDOM () {$1;}' unless defined(&CP0_RANDOM);
    eval 'sub CP0_ENTRYLO0 () {$2;}' unless defined(&CP0_ENTRYLO0);
    eval 'sub CP0_ENTRYLO1 () {$3;}' unless defined(&CP0_ENTRYLO1);
    eval 'sub CP0_CONTEXT () {$4;}' unless defined(&CP0_CONTEXT);
    eval 'sub CP0_PAGEMASK () {$5;}' unless defined(&CP0_PAGEMASK);
    eval 'sub CP0_WIRED () {$6;}' unless defined(&CP0_WIRED);
    eval 'sub CP0_BADVADDR () {$8;}' unless defined(&CP0_BADVADDR);
    eval 'sub CP0_COUNT () {$9;}' unless defined(&CP0_COUNT);
    eval 'sub CP0_ENTRYHI () {$10;}' unless defined(&CP0_ENTRYHI);
    eval 'sub CP0_COMPARE () {$11;}' unless defined(&CP0_COMPARE);
    eval 'sub CP0_STATUS () {$12;}' unless defined(&CP0_STATUS);
    eval 'sub CP0_CAUSE () {$13;}' unless defined(&CP0_CAUSE);
    eval 'sub CP0_EPC () {$14;}' unless defined(&CP0_EPC);
    eval 'sub CP0_PRID () {$15;}' unless defined(&CP0_PRID);
    eval 'sub CP0_CONFIG () {$16;}' unless defined(&CP0_CONFIG);
    eval 'sub CP0_LLADDR () {$17;}' unless defined(&CP0_LLADDR);
    eval 'sub CP0_WATCHLO () {$18;}' unless defined(&CP0_WATCHLO);
    eval 'sub CP0_WATCHHI () {$19;}' unless defined(&CP0_WATCHHI);
    eval 'sub CP0_XCONTEXT () {$20;}' unless defined(&CP0_XCONTEXT);
    eval 'sub CP0_FRAMEMASK () {$21;}' unless defined(&CP0_FRAMEMASK);
    eval 'sub CP0_DIAGNOSTIC () {$22;}' unless defined(&CP0_DIAGNOSTIC);
    eval 'sub CP0_PERFORMANCE () {$25;}' unless defined(&CP0_PERFORMANCE);
    eval 'sub CP0_ECC () {$26;}' unless defined(&CP0_ECC);
    eval 'sub CP0_CACHEERR () {$27;}' unless defined(&CP0_CACHEERR);
    eval 'sub CP0_TAGLO () {$28;}' unless defined(&CP0_TAGLO);
    eval 'sub CP0_TAGHI () {$29;}' unless defined(&CP0_TAGHI);
    eval 'sub CP0_ERROREPC () {$30;}' unless defined(&CP0_ERROREPC);
    eval 'sub CP0_IBASE () {$0;}' unless defined(&CP0_IBASE);
    eval 'sub CP0_IBOUND () {$1;}' unless defined(&CP0_IBOUND);
    eval 'sub CP0_DBASE () {$2;}' unless defined(&CP0_DBASE);
    eval 'sub CP0_DBOUND () {$3;}' unless defined(&CP0_DBOUND);
    eval 'sub CP0_CALG () {$17;}' unless defined(&CP0_CALG);
    eval 'sub CP0_IWATCH () {$18;}' unless defined(&CP0_IWATCH);
    eval 'sub CP0_DWATCH () {$19;}' unless defined(&CP0_DWATCH);
    eval 'sub CP1_REVISION () {$0;}' unless defined(&CP1_REVISION);
    eval 'sub CP1_STATUS () {$31;}' unless defined(&CP1_STATUS);
    eval 'sub PM_4K () {0x00000000;}' unless defined(&PM_4K);
    eval 'sub PM_16K () {0x00006000;}' unless defined(&PM_16K);
    eval 'sub PM_64K () {0x0001e000;}' unless defined(&PM_64K);
    eval 'sub PM_256K () {0x0007e000;}' unless defined(&PM_256K);
    eval 'sub PM_1M () {0x001fe000;}' unless defined(&PM_1M);
    eval 'sub PM_4M () {0x007fe000;}' unless defined(&PM_4M);
    eval 'sub PM_16M () {0x01ffe000;}' unless defined(&PM_16M);
    eval 'sub PL_4K () {12;}' unless defined(&PL_4K);
    eval 'sub PL_16K () {14;}' unless defined(&PL_16K);
    eval 'sub PL_64K () {16;}' unless defined(&PL_64K);
    eval 'sub PL_256K () {18;}' unless defined(&PL_256K);
    eval 'sub PL_1M () {20;}' unless defined(&PL_1M);
    eval 'sub PL_4M () {22;}' unless defined(&PL_4M);
    eval 'sub PL_16M () {24;}' unless defined(&PL_16M);
    eval 'sub read_32bit_cp0_register {
        local($source) = @_;
	    eval q(({ \'int\'  &__res;  &__asm__  &__volatile__( \\"mfc0\\\\t%0,\\" &STR($source) : \\"=r\\" ( &__res));  &__res;}));
    }' unless defined(&read_32bit_cp0_register);
    eval 'sub read_64bit_cp0_register {
        local($source) = @_;
	    eval q(({ \'int\'  &__res;  &__asm__  &__volatile__( \\".set\\\\tmips3\\\\n\\\\t\\" \\"dmfc0\\\\t%0,\\" &STR($source)\\"\\\\n\\\\t\\" \\".set\\\\tmips0\\" : \\"=r\\" ( &__res));  &__res;}));
    }' unless defined(&read_64bit_cp0_register);
    eval 'sub write_32bit_cp0_register {
        local($register,$value) = @_;
	    eval q( &__asm__  &__volatile__( \\"mtc0\\\\t%0,\\" &STR($register) : : \\"r\\" ($value)););
    }' unless defined(&write_32bit_cp0_register);
    eval 'sub write_64bit_cp0_register {
        local($register,$value) = @_;
	    eval q( &__asm__  &__volatile__( \\".set\\\\tmips3\\\\n\\\\t\\" \\"dmtc0\\\\t%0,\\" &STR($register)\\"\\\\n\\\\t\\" \\".set\\\\tmips0\\" : : \\"r\\" ($value)));
    }' unless defined(&write_64bit_cp0_register);
    eval 'sub IE_SW0 () {(1<< 8);}' unless defined(&IE_SW0);
    eval 'sub IE_SW1 () {(1<< 9);}' unless defined(&IE_SW1);
    eval 'sub IE_IRQ0 () {(1<<10);}' unless defined(&IE_IRQ0);
    eval 'sub IE_IRQ1 () {(1<<11);}' unless defined(&IE_IRQ1);
    eval 'sub IE_IRQ2 () {(1<<12);}' unless defined(&IE_IRQ2);
    eval 'sub IE_IRQ3 () {(1<<13);}' unless defined(&IE_IRQ3);
    eval 'sub IE_IRQ4 () {(1<<14);}' unless defined(&IE_IRQ4);
    eval 'sub IE_IRQ5 () {(1<<15);}' unless defined(&IE_IRQ5);
    eval 'sub C_SW0 () {(1<< 8);}' unless defined(&C_SW0);
    eval 'sub C_SW1 () {(1<< 9);}' unless defined(&C_SW1);
    eval 'sub C_IRQ0 () {(1<<10);}' unless defined(&C_IRQ0);
    eval 'sub C_IRQ1 () {(1<<11);}' unless defined(&C_IRQ1);
    eval 'sub C_IRQ2 () {(1<<12);}' unless defined(&C_IRQ2);
    eval 'sub C_IRQ3 () {(1<<13);}' unless defined(&C_IRQ3);
    eval 'sub C_IRQ4 () {(1<<14);}' unless defined(&C_IRQ4);
    eval 'sub C_IRQ5 () {(1<<15);}' unless defined(&C_IRQ5);
    unless(defined(&_LANGUAGE_ASSEMBLY)) {
	eval 'sub __BUILD_SET_CP0 {
	    local($name,$register) = @_;
    	    eval q( &extern  &__inline__ \'unsigned int set_cp0_\'$name(\'unsigned int change\', \'unsigned int new\') { \'unsigned int res\';  &res =  &read_32bit_cp0_register;  &res &= ~ &change;  &res |= ( &new &  &change);  &if  &write_32bit_cp0_register($register,  &res);  &return  &res; });
	}' unless defined(&__BUILD_SET_CP0);
    }
    eval 'sub load_linked {
        local($addr) = @_;
	    eval q(({ \'unsigned int __res\';  &__asm__  &__volatile__( \\"ll\\\\t%0,(%1)\\" : \\"=r\\" : \\"r\\" ( ($addr)));  &__res; }));
    }' unless defined(&load_linked);
    eval 'sub store_conditional {
        local($addr,$value) = @_;
	    eval q(({ \'int\'  &__res;  &__asm__  &__volatile__( \\"sc\\\\t%0,(%2)\\" : \\"=r\\" ( &__res) : \\"0\\" ($value), \\"r\\" ($addr));  &__res; }));
    }' unless defined(&store_conditional);
    eval 'sub ST0_IE () {0x00000001;}' unless defined(&ST0_IE);
    eval 'sub ST0_EXL () {0x00000002;}' unless defined(&ST0_EXL);
    eval 'sub ST0_ERL () {0x00000004;}' unless defined(&ST0_ERL);
    eval 'sub ST0_KSU () {0x00000018;}' unless defined(&ST0_KSU);
    eval 'sub KSU_USER () {0x00000010;}' unless defined(&KSU_USER);
    eval 'sub KSU_SUPERVISOR () {0x00000008;}' unless defined(&KSU_SUPERVISOR);
    eval 'sub KSU_KERNEL () {0x00000000;}' unless defined(&KSU_KERNEL);
    eval 'sub ST0_UX () {0x00000020;}' unless defined(&ST0_UX);
    eval 'sub ST0_SX () {0x00000040;}' unless defined(&ST0_SX);
    eval 'sub ST0_KX () {0x00000080;}' unless defined(&ST0_KX);
    eval 'sub ST0_IEC () {0x00000001;}' unless defined(&ST0_IEC);
    eval 'sub ST0_KUC () {0x00000002;}' unless defined(&ST0_KUC);
    eval 'sub ST0_IEP () {0x00000004;}' unless defined(&ST0_IEP);
    eval 'sub ST0_KUP () {0x00000008;}' unless defined(&ST0_KUP);
    eval 'sub ST0_IEO () {0x00000010;}' unless defined(&ST0_IEO);
    eval 'sub ST0_KUO () {0x00000020;}' unless defined(&ST0_KUO);
    eval 'sub ST0_UM () {<1<< 4);}' unless defined(&ST0_UM);
    eval 'sub ST0_IL () {(1<< 23);}' unless defined(&ST0_IL);
    eval 'sub ST0_DL () {(1<< 24);}' unless defined(&ST0_DL);
    eval 'sub ST0_IM () {0x0000ff00;}' unless defined(&ST0_IM);
    eval 'sub STATUSB_IP0 () {8;}' unless defined(&STATUSB_IP0);
    eval 'sub STATUSF_IP0 () {(1<< 8);}' unless defined(&STATUSF_IP0);
    eval 'sub STATUSB_IP1 () {9;}' unless defined(&STATUSB_IP1);
    eval 'sub STATUSF_IP1 () {(1<< 9);}' unless defined(&STATUSF_IP1);
    eval 'sub STATUSB_IP2 () {10;}' unless defined(&STATUSB_IP2);
    eval 'sub STATUSF_IP2 () {(1<< 10);}' unless defined(&STATUSF_IP2);
    eval 'sub STATUSB_IP3 () {11;}' unless defined(&STATUSB_IP3);
    eval 'sub STATUSF_IP3 () {(1<< 11);}' unless defined(&STATUSF_IP3);
    eval 'sub STATUSB_IP4 () {12;}' unless defined(&STATUSB_IP4);
    eval 'sub STATUSF_IP4 () {(1<< 12);}' unless defined(&STATUSF_IP4);
    eval 'sub STATUSB_IP5 () {13;}' unless defined(&STATUSB_IP5);
    eval 'sub STATUSF_IP5 () {(1<< 13);}' unless defined(&STATUSF_IP5);
    eval 'sub STATUSB_IP6 () {14;}' unless defined(&STATUSB_IP6);
    eval 'sub STATUSF_IP6 () {(1<< 14);}' unless defined(&STATUSF_IP6);
    eval 'sub STATUSB_IP7 () {15;}' unless defined(&STATUSB_IP7);
    eval 'sub STATUSF_IP7 () {(1<< 15);}' unless defined(&STATUSF_IP7);
    eval 'sub ST0_DE () {0x00010000;}' unless defined(&ST0_DE);
    eval 'sub ST0_CE () {0x00020000;}' unless defined(&ST0_CE);
    eval 'sub ST0_CH () {0x00040000;}' unless defined(&ST0_CH);
    eval 'sub ST0_SR () {0x00100000;}' unless defined(&ST0_SR);
    eval 'sub ST0_BEV () {0x00400000;}' unless defined(&ST0_BEV);
    eval 'sub ST0_RE () {0x02000000;}' unless defined(&ST0_RE);
    eval 'sub ST0_FR () {0x04000000;}' unless defined(&ST0_FR);
    eval 'sub ST0_CU () {0xf0000000;}' unless defined(&ST0_CU);
    eval 'sub ST0_CU0 () {0x10000000;}' unless defined(&ST0_CU0);
    eval 'sub ST0_CU1 () {0x20000000;}' unless defined(&ST0_CU1);
    eval 'sub ST0_CU2 () {0x40000000;}' unless defined(&ST0_CU2);
    eval 'sub ST0_CU3 () {0x80000000;}' unless defined(&ST0_CU3);
    eval 'sub ST0_XX () {0x80000000;}' unless defined(&ST0_XX);
    eval 'sub CAUSEB_EXCCODE () {2;}' unless defined(&CAUSEB_EXCCODE);
    eval 'sub CAUSEF_EXCCODE () {(31<< 2);}' unless defined(&CAUSEF_EXCCODE);
    eval 'sub CAUSEB_IP () {8;}' unless defined(&CAUSEB_IP);
    eval 'sub CAUSEF_IP () {(255<< 8);}' unless defined(&CAUSEF_IP);
    eval 'sub CAUSEB_IP0 () {8;}' unless defined(&CAUSEB_IP0);
    eval 'sub CAUSEF_IP0 () {(1<< 8);}' unless defined(&CAUSEF_IP0);
    eval 'sub CAUSEB_IP1 () {9;}' unless defined(&CAUSEB_IP1);
    eval 'sub CAUSEF_IP1 () {(1<< 9);}' unless defined(&CAUSEF_IP1);
    eval 'sub CAUSEB_IP2 () {10;}' unless defined(&CAUSEB_IP2);
    eval 'sub CAUSEF_IP2 () {(1<< 10);}' unless defined(&CAUSEF_IP2);
    eval 'sub CAUSEB_IP3 () {11;}' unless defined(&CAUSEB_IP3);
    eval 'sub CAUSEF_IP3 () {(1<< 11);}' unless defined(&CAUSEF_IP3);
    eval 'sub CAUSEB_IP4 () {12;}' unless defined(&CAUSEB_IP4);
    eval 'sub CAUSEF_IP4 () {(1<< 12);}' unless defined(&CAUSEF_IP4);
    eval 'sub CAUSEB_IP5 () {13;}' unless defined(&CAUSEB_IP5);
    eval 'sub CAUSEF_IP5 () {(1<< 13);}' unless defined(&CAUSEF_IP5);
    eval 'sub CAUSEB_IP6 () {14;}' unless defined(&CAUSEB_IP6);
    eval 'sub CAUSEF_IP6 () {(1<< 14);}' unless defined(&CAUSEF_IP6);
    eval 'sub CAUSEB_IP7 () {15;}' unless defined(&CAUSEB_IP7);
    eval 'sub CAUSEF_IP7 () {(1<< 15);}' unless defined(&CAUSEF_IP7);
    eval 'sub CAUSEB_IV () {23;}' unless defined(&CAUSEB_IV);
    eval 'sub CAUSEF_IV () {(1<< 23);}' unless defined(&CAUSEF_IV);
    eval 'sub CAUSEB_CE () {28;}' unless defined(&CAUSEB_CE);
    eval 'sub CAUSEF_CE () {(3<< 28);}' unless defined(&CAUSEF_CE);
    eval 'sub CAUSEB_BD () {31;}' unless defined(&CAUSEB_BD);
    eval 'sub CAUSEF_BD () {(1<< 31);}' unless defined(&CAUSEF_BD);
    eval 'sub CONF_CM_CACHABLE_NO_WA () {0;}' unless defined(&CONF_CM_CACHABLE_NO_WA);
    eval 'sub CONF_CM_CACHABLE_WA () {1;}' unless defined(&CONF_CM_CACHABLE_WA);
    eval 'sub CONF_CM_UNCACHED () {2;}' unless defined(&CONF_CM_UNCACHED);
    eval 'sub CONF_CM_CACHABLE_NONCOHERENT () {3;}' unless defined(&CONF_CM_CACHABLE_NONCOHERENT);
    eval 'sub CONF_CM_CACHABLE_CE () {4;}' unless defined(&CONF_CM_CACHABLE_CE);
    eval 'sub CONF_CM_CACHABLE_COW () {5;}' unless defined(&CONF_CM_CACHABLE_COW);
    eval 'sub CONF_CM_CACHABLE_CUW () {6;}' unless defined(&CONF_CM_CACHABLE_CUW);
    eval 'sub CONF_CM_CACHABLE_ACCELERATED () {7;}' unless defined(&CONF_CM_CACHABLE_ACCELERATED);
    eval 'sub CONF_CM_CMASK () {7;}' unless defined(&CONF_CM_CMASK);
    eval 'sub CONF_DB () {(1<< 4);}' unless defined(&CONF_DB);
    eval 'sub CONF_IB () {(1<< 5);}' unless defined(&CONF_IB);
    eval 'sub CONF_SC () {(1<< 17);}' unless defined(&CONF_SC);
    eval 'sub CE0_CYCLES () {0;}' unless defined(&CE0_CYCLES);
    eval 'sub CE0_INSN_ISSUED () {1;}' unless defined(&CE0_INSN_ISSUED);
    eval 'sub CE0_LPSC_ISSUED () {2;}' unless defined(&CE0_LPSC_ISSUED);
    eval 'sub CE0_S_ISSUED () {3;}' unless defined(&CE0_S_ISSUED);
    eval 'sub CE0_SC_ISSUED () {4;}' unless defined(&CE0_SC_ISSUED);
    eval 'sub CE0_SC_FAILED () {5;}' unless defined(&CE0_SC_FAILED);
    eval 'sub CE0_BRANCH_DECODED () {6;}' unless defined(&CE0_BRANCH_DECODED);
    eval 'sub CE0_QW_WB_SECONDARY () {7;}' unless defined(&CE0_QW_WB_SECONDARY);
    eval 'sub CE0_CORRECTED_ECC_ERRORS () {8;}' unless defined(&CE0_CORRECTED_ECC_ERRORS);
    eval 'sub CE0_ICACHE_MISSES () {9;}' unless defined(&CE0_ICACHE_MISSES);
    eval 'sub CE0_SCACHE_I_MISSES () {10;}' unless defined(&CE0_SCACHE_I_MISSES);
    eval 'sub CE0_SCACHE_I_WAY_MISSPREDICTED () {11;}' unless defined(&CE0_SCACHE_I_WAY_MISSPREDICTED);
    eval 'sub CE0_EXT_INTERVENTIONS_REQ () {12;}' unless defined(&CE0_EXT_INTERVENTIONS_REQ);
    eval 'sub CE0_EXT_INVALIDATE_REQ () {13;}' unless defined(&CE0_EXT_INVALIDATE_REQ);
    eval 'sub CE0_VIRTUAL_COHERENCY_COND () {14;}' unless defined(&CE0_VIRTUAL_COHERENCY_COND);
    eval 'sub CE0_INSN_GRADUATED () {15;}' unless defined(&CE0_INSN_GRADUATED);
    eval 'sub CE1_CYCLES () {0;}' unless defined(&CE1_CYCLES);
    eval 'sub CE1_INSN_GRADUATED () {1;}' unless defined(&CE1_INSN_GRADUATED);
    eval 'sub CE1_LPSC_GRADUATED () {2;}' unless defined(&CE1_LPSC_GRADUATED);
    eval 'sub CE1_S_GRADUATED () {3;}' unless defined(&CE1_S_GRADUATED);
    eval 'sub CE1_SC_GRADUATED () {4;}' unless defined(&CE1_SC_GRADUATED);
    eval 'sub CE1_FP_INSN_GRADUATED () {5;}' unless defined(&CE1_FP_INSN_GRADUATED);
    eval 'sub CE1_QW_WB_PRIMARY () {6;}' unless defined(&CE1_QW_WB_PRIMARY);
    eval 'sub CE1_TLB_REFILL () {7;}' unless defined(&CE1_TLB_REFILL);
    eval 'sub CE1_BRANCH_MISSPREDICTED () {8;}' unless defined(&CE1_BRANCH_MISSPREDICTED);
    eval 'sub CE1_DCACHE_MISS () {9;}' unless defined(&CE1_DCACHE_MISS);
    eval 'sub CE1_SCACHE_D_MISSES () {10;}' unless defined(&CE1_SCACHE_D_MISSES);
    eval 'sub CE1_SCACHE_D_WAY_MISSPREDICTED () {11;}' unless defined(&CE1_SCACHE_D_WAY_MISSPREDICTED);
    eval 'sub CE1_EXT_INTERVENTION_HITS () {12;}' unless defined(&CE1_EXT_INTERVENTION_HITS);
    eval 'sub CE1_EXT_INVALIDATE_REQ () {13;}' unless defined(&CE1_EXT_INVALIDATE_REQ);
    eval 'sub CE1_SP_HINT_TO_CEXCL_SC_BLOCKS () {14;}' unless defined(&CE1_SP_HINT_TO_CEXCL_SC_BLOCKS);
    eval 'sub CE1_SP_HINT_TO_SHARED_SC_BLOCKS () {15;}' unless defined(&CE1_SP_HINT_TO_SHARED_SC_BLOCKS);
    eval 'sub CEB_USER () {8;}' unless defined(&CEB_USER);
    eval 'sub CEB_SUPERVISOR () {4;}' unless defined(&CEB_SUPERVISOR);
    eval 'sub CEB_KERNEL () {2;}' unless defined(&CEB_KERNEL);
    eval 'sub CEB_EXL () {1;}' unless defined(&CEB_EXL);
    unless(defined(&_LANGUAGE_ASSEMBLY)) {
    }
}
1;
