require '_h2ph_pre.ph';

unless(defined(&STRIOC)) {
    sub STRIOC () {	(ord('S') << 8);}
}
unless(defined(&I_STR)) {
    sub I_STR () {	( &STRIOC | 010);}
}
unless(defined(&I_PUSH)) {
    sub I_PUSH () {	( &STRIOC | 02);}
}
unless(defined(&I_LINK)) {
    sub I_LINK () {	( &STRIOC | 014);}
}
unless(defined(&I_UNLINK)) {
    sub I_UNLINK () {	( &STRIOC | 015);}
}
unless(defined(&QIOCATTACH)) {
    sub QIOCATTACH () {	 &_IOW(ord('Q'),1,'struct shmiqreq');}
}
unless(defined(&QIOCDETACH)) {
    sub QIOCDETACH () {	 &_IO(ord('Q'),2);}
}
unless(defined(&SHMIQ_OVERFLOW)) {
    sub SHMIQ_OVERFLOW () {	1;}
}
unless(defined(&SHMIQ_CORRUPTED)) {
    sub SHMIQ_CORRUPTED () {	2;}
}
unless(defined(&QIOCGETINDX)) {
    sub QIOCGETINDX () {	 &_IOWR(ord('Q'), 8, 'int');}
}
unless(defined(&QIOCSERVICED)) {
    sub QIOCSERVICED () {	 &_IO(ord('Q'), 3);}
}
unless(defined(&QIOCIISTR)) {
    sub QIOCIISTR () {	 &_IOW(ord('Q'), 7, 'struct muxioctl');}
}
unless(defined(&QIOCURSTRK)) {
    sub QIOCURSTRK () {	 &_IOW(ord('Q'), 4, 'int');}
}
unless(defined(&QIOCURSIGN)) {
    sub QIOCURSIGN () {	 &_IOW(ord('Q'), 5, 'int' [4]);}
}
unless(defined(&QIOCSETCURS)) {
    sub QIOCSETCURS () {	 &_IOWR(ord('Q'), 9, 'struct shmiqsetcurs');}
}
unless(defined(&QIOCSETCPOS)) {
    sub QIOCSETCPOS () {	 &_IOWR(ord('Q'), 10, 'struct shmiqsetcpos');}
}
unless(defined(&QIOCGETITIME)) {
    sub QIOCGETITIME () {	 &_IOR(ord('Q'), 11,  &time_t);}
}
unless(defined(&QIOCSETSCRN)) {
    sub QIOCSETSCRN () {	 &_IOW(ord('Q'),6,'int');}
}
unless(defined(&IDEV_MAX_NAME_LEN)) {
    sub IDEV_MAX_NAME_LEN () {	15;}
}
unless(defined(&IDEV_MAX_TYPE_LEN)) {
    sub IDEV_MAX_TYPE_LEN () {	15;}
}
unless(defined(&IDEV_HAS_KEYMAP)) {
    sub IDEV_HAS_KEYMAP () {	0x01;}
}
unless(defined(&IDEV_HAS_PROXIMITY)) {
    sub IDEV_HAS_PROXIMITY () {	0x02;}
}
unless(defined(&IDEV_HAS_PCKBD)) {
    sub IDEV_HAS_PCKBD () {	0x04;}
}
unless(defined(&IDEV_KEYMAP_NAME_LEN)) {
    sub IDEV_KEYMAP_NAME_LEN () {	15;}
}
unless(defined(&IDEV_ABSOLUTE)) {
    sub IDEV_ABSOLUTE () {	0x0;}
}
unless(defined(&IDEV_RELATIVE)) {
    sub IDEV_RELATIVE () {	0x1;}
}
unless(defined(&IDEV_EITHER)) {
    sub IDEV_EITHER () {	0x2;}
}
unless(defined(&IDEVGETDEVICEDESC)) {
    sub IDEVGETDEVICEDESC () {	 &_IOWR(ord('i'), 0,  &idevDesc);}
}
unless(defined(&IDEVGETVALUATORDESC)) {
    sub IDEVGETVALUATORDESC () {	 &_IOWR(ord('i'), 1,  &idevGetSetValDesc);}
}
unless(defined(&IDEVGETKEYMAPDESC)) {
    sub IDEVGETKEYMAPDESC () {	 &_IOWR(ord('i'), 2,  &idevKeymapDesc);}
}
unless(defined(&IDEVINITDEVICE)) {
    sub IDEVINITDEVICE () {	 &_IOW (ord('i'), 51, 'unsigned int');}
}
if(defined(&__KERNEL__)) {
    eval 'sub SHMIQ_OFF () { &_IO(ord(\'Q\'),1);}' unless defined(&SHMIQ_OFF);
    eval 'sub SHMIQ_ON () { &_IO(ord(\'Q\'),2);}' unless defined(&SHMIQ_ON);
}
1;
