require '_h2ph_pre.ph';

unless(defined(&__ASM_MIPS_SYSTEM_H)) {
    eval 'sub __ASM_MIPS_SYSTEM_H () {1;}' unless defined(&__ASM_MIPS_SYSTEM_H);
    require 'asm/sgidefs.ph';
    require 'linux/kernel.ph';
    eval 'sub __save_flags {
        local($x) = @_;
	    eval q( &__asm__  &__volatile__( \\".set\\\\tnoreorder\\\\n\\\\t\\" \\"mfc0\\\\t%0,$12\\\\n\\\\t\\" \\".set\\\\treorder\\" : \\"=r\\" ($x) : : \\"memory\\"));
    }' unless defined(&__save_flags);
    eval 'sub __save_and_cli {
        local($x) = @_;
	    eval q( &__asm__  &__volatile__( \\".set\\\\tnoreorder\\\\n\\\\t\\" \\".set\\\\tnoat\\\\n\\\\t\\" \\"mfc0\\\\t%0,$12\\\\n\\\\t\\" \\"ori\\\\t$1,%0,1\\\\n\\\\t\\" \\"xori\\\\t$1,1\\\\n\\\\t\\" \\"mtc0\\\\t$1,$12\\\\n\\\\t\\" \\"nop\\\\n\\\\t\\" \\"nop\\\\n\\\\t\\" \\"nop\\\\n\\\\t\\" \\".set\\\\tat\\\\n\\\\t\\" \\".set\\\\treorder\\" : \\"=r\\" ($x) : : \\"$1\\", \\"memory\\"));
    }' unless defined(&__save_and_cli);
    eval 'sub sti () {
        eval q( &__sti());
    }' unless defined(&sti);
    eval 'sub cli () {
        eval q( &__cli());
    }' unless defined(&cli);
    eval 'sub save_flags {
        local($x) = @_;
	    eval q( &__save_flags($x));
    }' unless defined(&save_flags);
    eval 'sub save_and_cli {
        local($x) = @_;
	    eval q( &__save_and_cli($x));
    }' unless defined(&save_and_cli);
    eval 'sub restore_flags {
        local($x) = @_;
	    eval q( &__restore_flags($x));
    }' unless defined(&restore_flags);
    eval 'sub mb () {
        eval q( &__asm__  &__volatile__( \\"# prevent instructions being moved around\\\\n\\\\t\\" \\".set\\\\tnoreorder\\\\n\\\\t\\" \\"# 8 nops to fool the R4400 pipeline\\\\n\\\\t\\" \\"nop;nop;nop;nop;nop;nop;nop;nop\\\\n\\\\t\\" \\".set\\\\treorder\\" : : : \\"memory\\"));
    }' unless defined(&mb);
    eval 'sub rmb () {
        eval q( &mb());
    }' unless defined(&rmb);
    eval 'sub wmb () {
        eval q( &mb());
    }' unless defined(&wmb);
    if(!defined ( &_LANGUAGE_ASSEMBLY)) {
    }
    eval 'sub switch_to {
        local($prev,$next,$last) = @_;
	    eval q( &do { ($last) =  &resume($prev, $next); }  &while(0));
    }' unless defined(&switch_to);
    if(((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS2) ? &_MIPS_ISA_MIPS2 : 0)) || ((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS3) ? &_MIPS_ISA_MIPS3 : 0)) || ((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS4) ? &_MIPS_ISA_MIPS4 : 0)) || ((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS5) ? &_MIPS_ISA_MIPS5 : 0))) {
    } else {
    }
    eval 'sub xchg {
        local($ptr,$x) = @_;
	    eval q((( &__typeof__(*)) &__xchg(($x),($ptr),$sizeof{($ptr)})));
    }' unless defined(&xchg);
    eval 'sub tas {
        local($ptr) = @_;
	    eval q(( &xchg(($ptr),1)));
    }' unless defined(&tas);
    if(defined( &__mips64)) {
    }
}
1;
