require '_h2ph_pre.ph';

unless(defined(&_DIRENT_H)) {
    eval 'sub _DIRENT_H () {1;}' unless defined(&_DIRENT_H);
    require 'features.ph';
    require 'gnu/types.ph';
    require 'direntry.ph';
    if((defined (defined(&__USE_BSD) ? &__USE_BSD : 0) || defined (defined(&__USE_MISC) ? &__USE_MISC : 0))  && !defined (defined(&d_fileno) ? &d_fileno : 0)) {
	eval 'sub d_ino () { &d_fileno;}' unless defined(&d_ino);
    }
    if(defined(&_DIRENT_HAVE_D_NAMLEN)) {
	eval 'sub _D_EXACT_NAMLEN {
	    local($d) = @_;
    	    eval q((($d)-> &d_namlen));
	}' unless defined(&_D_EXACT_NAMLEN);
	eval 'sub _D_ALLOC_NAMLEN {
	    local($d) = @_;
    	    eval q(( &_D_EXACT_NAMLEN ($d) + 1));
	}' unless defined(&_D_ALLOC_NAMLEN);
    } else {
	eval 'sub _D_EXACT_NAMLEN {
	    local($d) = @_;
    	    eval q(( &strlen (($d)-> &d_name)));
	}' unless defined(&_D_EXACT_NAMLEN);
	if(defined(&_DIRENT_HAVE_D_RECLEN)) {
	    eval 'sub _D_ALLOC_NAMLEN {
	        local($d) = @_;
    		eval q((( ($d) + ($d)-> &d_reclen) - ($d)-> $d_name[0]));
	    }' unless defined(&_D_ALLOC_NAMLEN);
	} else {
	    eval 'sub _D_ALLOC_NAMLEN {
	        local($d) = @_;
    		eval q(($sizeof{$d}-> &d_name > 1? $sizeof{$d}-> &d_name :  &_D_EXACT_NAMLEN ($d) + 1));
	    }' unless defined(&_D_ALLOC_NAMLEN);
	}
    }
    if(defined(&__USE_BSD)) {
	eval 'sub IFTODT {
	    local($mode) = @_;
    	    eval q(((($mode) & 0170000) >> 12));
	}' unless defined(&IFTODT);
	eval 'sub DTTOIF {
	    local($dirtype) = @_;
    	    eval q((($dirtype) << 12));
	}' unless defined(&DTTOIF);
    }
    if(defined (defined(&__USE_POSIX) ? &__USE_POSIX : 0) || defined (defined(&__USE_MISC) ? &__USE_MISC : 0)) {
    }
    if(defined (defined(&__USE_BSD) ? &__USE_BSD : 0) || defined (defined(&__USE_MISC) ? &__USE_MISC : 0)) {
	if(defined (defined(&__OPTIMIZE__) ? &__OPTIMIZE__ : 0)  && defined (defined(&_DIR_dirfd) ? &_DIR_dirfd : 0)) {
	    eval 'sub dirfd {
	        local($dirp) = @_;
    		eval q( &_DIR_dirfd ($dirp));
	    }' unless defined(&dirfd);
	}
	unless(defined(&MAXNAMLEN)) {
	    require 'posix1_lim.ph';
	    if(defined(&NAME_MAX)) {
		eval 'sub MAXNAMLEN () { &NAME_MAX;}' unless defined(&MAXNAMLEN);
	    } else {
		eval 'sub MAXNAMLEN () {255;}' unless defined(&MAXNAMLEN);
	    }
	}
	require 'gnu/types.ph';
	eval 'sub __need_size_t () {1;}' unless defined(&__need_size_t);
	require 'stddef.ph';
    }
}
1;
