require '_h2ph_pre.ph';

unless(defined(&_SYS_ASM_H)) {
    eval 'sub _SYS_ASM_H () {1;}' unless defined(&_SYS_ASM_H);
    require 'asm/sgidefs.ph';
    unless(defined(&CAT)) {
	if(defined(&__STDC__)) {
	    eval 'sub __CAT {
	        local($str1,$str2) = @_;
    		eval q($str1$str2);
	    }' unless defined(&__CAT);
	} else {
	    eval 'sub __CAT {
	        local($str1,$str2) = @_;
    		eval q( &str1str2);
	    }' unless defined(&__CAT);
	}
	eval 'sub CAT {
	    local($str1,$str2) = @_;
    	    eval q( &__CAT($str1,$str2));
	}' unless defined(&CAT);
    }
    eval 'sub PTR () {. &word;}' unless defined(&PTR);
    eval 'sub PTRSIZE () {4;}' unless defined(&PTRSIZE);
    eval 'sub PTRLOG () {2;}' unless defined(&PTRLOG);
    if(defined(&__PIC__)) {
	eval 'sub CPRESTORE {
	    local($register) = @_;
    	    eval q(. &cprestore $register);
	}' unless defined(&CPRESTORE);
	eval 'sub CPADD {
	    local($register) = @_;
    	    eval q(. &cpadd $register);
	}' unless defined(&CPADD);
	eval 'sub CPLOAD {
	    local($register) = @_;
    	    eval q(. &cpload $register);
	}' unless defined(&CPLOAD);
    } else {
	eval 'sub CPRESTORE {
	    local($register) = @_;
    	    eval q();
	}' unless defined(&CPRESTORE);
	eval 'sub CPADD {
	    local($register) = @_;
    	    eval q();
	}' unless defined(&CPADD);
	eval 'sub CPLOAD {
	    local($register) = @_;
    	    eval q();
	}' unless defined(&CPLOAD);
    }
    eval 'sub LEAF {
        local($symbol) = @_;
	    eval q(. &globl $symbol; . &align 2; . &type $symbol,@ &function; . &ent $symbol,0; $symbol: . &frame  &sp,0, &ra);
    }' unless defined(&LEAF);
    eval 'sub NESTED {
        local($symbol, $framesize, $rpc) = @_;
	    eval q(. &globl $symbol; . &align 2; . &type $symbol,@ &function; . &ent $symbol,0; $symbol: . &frame  &sp, $framesize, $rpc);
    }' unless defined(&NESTED);
    eval 'sub END {
        local($function) = @_;
	    eval q(. &end $function; . &size $function,.-$function);
    }' unless defined(&END);
    eval 'sub EXPORT {
        local($symbol) = @_;
	    eval q(. &globl $symbol; $symbol:);
    }' unless defined(&EXPORT);
    eval 'sub ABS {
        local($symbol,$value) = @_;
	    eval q(. &globl $symbol; $symbol = $value);
    }' unless defined(&ABS);
    eval 'sub PANIC {
        local($msg) = @_;
	    eval q(. &set  &push; . &set  &reorder;  &la  &a0,8 &f;  &jal  &panic; 9:  &b 9 &b; . &set  &pop;  &TEXT($msg));
    }' unless defined(&PANIC);
    eval 'sub PRINT {
        local($string) = @_;
	    eval q(. &set  &push; . &set  &reorder;  &la  &a0,8 &f;  &jal  &printk; . &set  &pop;  &TEXT($string));
    }' unless defined(&PRINT);
    eval 'sub TEXT {
        local($msg) = @_;
	    eval q(. &data; 8: . &asciiz $msg; . &previous;);
    }' unless defined(&TEXT);
    eval 'sub TTABLE {
        local($string) = @_;
	    eval q(. &text; . &word 1 &f; . &previous; . &data; 1: . &asciz $string; . &previous);
    }' unless defined(&TTABLE);
    if(((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS4) ? &_MIPS_ISA_MIPS4 : 0)) || ((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS5) ? &_MIPS_ISA_MIPS5 : 0))) {
	eval 'sub PREF {
	    local($hint,$addr) = @_;
    	    eval q( &pref $hint,$addr);
	}' unless defined(&PREF);
	eval 'sub PREFX {
	    local($hint,$addr) = @_;
    	    eval q( &prefx $hint,$addr);
	}' unless defined(&PREFX);
    } else {
	eval 'sub PREF () {1;}' unless defined(&PREF);
	eval 'sub PREFX () {1;}' unless defined(&PREFX);
    }
    if((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS1) ? &_MIPS_ISA_MIPS1 : 0)) {
	eval 'sub MOVN {
	    local($rd,$rs,$rt) = @_;
    	    eval q(. &set  &push; . &set  &reorder;  &beqz $rt,9 &f;  &move $rd,$rs; . &set  &pop; 9:);
	}' unless defined(&MOVN);
	eval 'sub MOVZ {
	    local($rd,$rs,$rt) = @_;
    	    eval q(. &set  &push; . &set  &reorder;  &bnez $rt,9 &f;  &move $rd,$rt; . &set  &pop; 9:);
	}' unless defined(&MOVZ);
    }
    if(((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS2) ? &_MIPS_ISA_MIPS2 : 0)) || ((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS3) ? &_MIPS_ISA_MIPS3 : 0))) {
	eval 'sub MOVN {
	    local($rd,$rs,$rt) = @_;
    	    eval q(. &set  &push; . &set  &noreorder;  &bnezl $rt,9 &f;  &move $rd,$rs; . &set  &pop; 9:);
	}' unless defined(&MOVN);
	eval 'sub MOVZ {
	    local($rd,$rs,$rt) = @_;
    	    eval q(. &set  &push; . &set  &noreorder;  &beqzl $rt,9 &f;  &movz $rd,$rs; . &set  &pop; 9:);
	}' unless defined(&MOVZ);
    }
    if(((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS4) ? &_MIPS_ISA_MIPS4 : 0)) || ((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS5) ? &_MIPS_ISA_MIPS5 : 0))) {
	eval 'sub MOVN {
	    local($rd,$rs,$rt) = @_;
    	    eval q( &movn $rd,$rs,$rt);
	}' unless defined(&MOVN);
	eval 'sub MOVZ {
	    local($rd,$rs,$rt) = @_;
    	    eval q( &movz $rd,$rs,$rt);
	}' unless defined(&MOVZ);
    }
    if(((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS1) ? &_MIPS_ISA_MIPS1 : 0)) || ((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS2) ? &_MIPS_ISA_MIPS2 : 0))) {
	eval 'sub ALSZ () {7;}' unless defined(&ALSZ);
	eval 'sub ALMASK () {~7;}' unless defined(&ALMASK);
    }
    if(((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS3) ? &_MIPS_ISA_MIPS3 : 0)) || ((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS4) ? &_MIPS_ISA_MIPS4 : 0)) || ((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS5) ? &_MIPS_ISA_MIPS5 : 0))) {
	eval 'sub ALSZ () {15;}' unless defined(&ALSZ);
	eval 'sub ALMASK () {~15;}' unless defined(&ALMASK);
    }
    if(defined(&__mips64)) {
	eval 'sub SZREG () {8;}' unless defined(&SZREG);
    } else {
	eval 'sub SZREG () {4;}' unless defined(&SZREG);
    }
    if(((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS1) ? &_MIPS_ISA_MIPS1 : 0)) || ((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS2) ? &_MIPS_ISA_MIPS2 : 0))) {
	eval 'sub REG_S () { &sw;}' unless defined(&REG_S);
	eval 'sub REG_L () { &lw;}' unless defined(&REG_L);
	eval 'sub PTR_SUBU () { &subu;}' unless defined(&PTR_SUBU);
	eval 'sub PTR_ADDU () { &addu;}' unless defined(&PTR_ADDU);
    }
    if(((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS3) ? &_MIPS_ISA_MIPS3 : 0)) || ((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS4) ? &_MIPS_ISA_MIPS4 : 0)) || ((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS5) ? &_MIPS_ISA_MIPS5 : 0))) {
	eval 'sub REG_S () { &sd;}' unless defined(&REG_S);
	eval 'sub REG_L () { &ld;}' unless defined(&REG_L);
	eval 'sub PTR_SUBU () { &subu;}' unless defined(&PTR_SUBU);
	eval 'sub PTR_ADDU () { &addu;}' unless defined(&PTR_ADDU);
    }
    if(((defined(&_MIPS_SZINT) ? &_MIPS_SZINT : 0) == 32)) {
	eval 'sub INT_ADD () { &add;}' unless defined(&INT_ADD);
	eval 'sub INT_ADDI () { &addi;}' unless defined(&INT_ADDI);
	eval 'sub INT_ADDU () { &addu;}' unless defined(&INT_ADDU);
	eval 'sub INT_ADDIU () { &addiu;}' unless defined(&INT_ADDIU);
	eval 'sub INT_SUB () { &add;}' unless defined(&INT_SUB);
	eval 'sub INT_SUBI () { &subi;}' unless defined(&INT_SUBI);
	eval 'sub INT_SUBU () { &subu;}' unless defined(&INT_SUBU);
	eval 'sub INT_SUBIU () { &subu;}' unless defined(&INT_SUBIU);
	eval 'sub INT_L () { &lw;}' unless defined(&INT_L);
	eval 'sub INT_S () { &sw;}' unless defined(&INT_S);
	eval 'sub LONG_SLL () { &sll;}' unless defined(&LONG_SLL);
	eval 'sub LONG_SLLV () { &sllv;}' unless defined(&LONG_SLLV);
	eval 'sub LONG_SRL () { &srl;}' unless defined(&LONG_SRL);
	eval 'sub LONG_SRLV () { &srlv;}' unless defined(&LONG_SRLV);
	eval 'sub LONG_SRA () { &sra;}' unless defined(&LONG_SRA);
	eval 'sub LONG_SRAV () { &srav;}' unless defined(&LONG_SRAV);
    }
    if(((defined(&_MIPS_SZINT) ? &_MIPS_SZINT : 0) == 64)) {
	eval 'sub INT_ADD () { &dadd;}' unless defined(&INT_ADD);
	eval 'sub INT_ADDI () { &daddi;}' unless defined(&INT_ADDI);
	eval 'sub INT_ADDU () { &daddu;}' unless defined(&INT_ADDU);
	eval 'sub INT_ADDIU () { &daddiu;}' unless defined(&INT_ADDIU);
	eval 'sub INT_SUB () { &dadd;}' unless defined(&INT_SUB);
	eval 'sub INT_SUBI () { &dsubi;}' unless defined(&INT_SUBI);
	eval 'sub INT_SUBU () { &dsubu;}' unless defined(&INT_SUBU);
	eval 'sub INT_SUBIU () { &dsubu;}' unless defined(&INT_SUBIU);
	eval 'sub INT_L () { &ld;}' unless defined(&INT_L);
	eval 'sub INT_S () { &sd;}' unless defined(&INT_S);
	eval 'sub LONG_SLL () { &dsll;}' unless defined(&LONG_SLL);
	eval 'sub LONG_SLLV () { &dsllv;}' unless defined(&LONG_SLLV);
	eval 'sub LONG_SRL () { &dsrl;}' unless defined(&LONG_SRL);
	eval 'sub LONG_SRLV () { &dsrlv;}' unless defined(&LONG_SRLV);
	eval 'sub LONG_SRA () { &dsra;}' unless defined(&LONG_SRA);
	eval 'sub LONG_SRAV () { &dsrav;}' unless defined(&LONG_SRAV);
    }
    if(((defined(&_MIPS_SZLONG) ? &_MIPS_SZLONG : 0) == 32)) {
	eval 'sub LONG_ADD () { &add;}' unless defined(&LONG_ADD);
	eval 'sub LONG_ADDI () { &addi;}' unless defined(&LONG_ADDI);
	eval 'sub LONG_ADDU () { &addu;}' unless defined(&LONG_ADDU);
	eval 'sub LONG_ADDIU () { &addiu;}' unless defined(&LONG_ADDIU);
	eval 'sub LONG_SUB () { &add;}' unless defined(&LONG_SUB);
	eval 'sub LONG_SUBI () { &subi;}' unless defined(&LONG_SUBI);
	eval 'sub LONG_SUBU () { &subu;}' unless defined(&LONG_SUBU);
	eval 'sub LONG_SUBIU () { &subu;}' unless defined(&LONG_SUBIU);
	eval 'sub LONG_L () { &lw;}' unless defined(&LONG_L);
	eval 'sub LONG_S () { &sw;}' unless defined(&LONG_S);
	eval 'sub LONG_SLL () { &sll;}' unless defined(&LONG_SLL);
	eval 'sub LONG_SLLV () { &sllv;}' unless defined(&LONG_SLLV);
	eval 'sub LONG_SRL () { &srl;}' unless defined(&LONG_SRL);
	eval 'sub LONG_SRLV () { &srlv;}' unless defined(&LONG_SRLV);
	eval 'sub LONG_SRA () { &sra;}' unless defined(&LONG_SRA);
	eval 'sub LONG_SRAV () { &srav;}' unless defined(&LONG_SRAV);
    }
    if(((defined(&_MIPS_SZLONG) ? &_MIPS_SZLONG : 0) == 64)) {
	eval 'sub LONG_ADD () { &dadd;}' unless defined(&LONG_ADD);
	eval 'sub LONG_ADDI () { &daddi;}' unless defined(&LONG_ADDI);
	eval 'sub LONG_ADDU () { &daddu;}' unless defined(&LONG_ADDU);
	eval 'sub LONG_ADDIU () { &daddiu;}' unless defined(&LONG_ADDIU);
	eval 'sub LONG_SUB () { &dadd;}' unless defined(&LONG_SUB);
	eval 'sub LONG_SUBI () { &dsubi;}' unless defined(&LONG_SUBI);
	eval 'sub LONG_SUBU () { &dsubu;}' unless defined(&LONG_SUBU);
	eval 'sub LONG_SUBIU () { &dsubu;}' unless defined(&LONG_SUBIU);
	eval 'sub LONG_L () { &ld;}' unless defined(&LONG_L);
	eval 'sub LONG_S () { &sd;}' unless defined(&LONG_S);
	eval 'sub LONG_SLL () { &dsll;}' unless defined(&LONG_SLL);
	eval 'sub LONG_SLLV () { &dsllv;}' unless defined(&LONG_SLLV);
	eval 'sub LONG_SRL () { &dsrl;}' unless defined(&LONG_SRL);
	eval 'sub LONG_SRLV () { &dsrlv;}' unless defined(&LONG_SRLV);
	eval 'sub LONG_SRA () { &dsra;}' unless defined(&LONG_SRA);
	eval 'sub LONG_SRAV () { &dsrav;}' unless defined(&LONG_SRAV);
    }
    if(((defined(&_MIPS_SZLONG) ? &_MIPS_SZLONG : 0) == 32)) {
	eval 'sub PTR_ADD () { &add;}' unless defined(&PTR_ADD);
	eval 'sub PTR_ADDI () { &addi;}' unless defined(&PTR_ADDI);
	eval 'sub PTR_ADDU () { &addu;}' unless defined(&PTR_ADDU);
	eval 'sub PTR_ADDIU () { &addiu;}' unless defined(&PTR_ADDIU);
	eval 'sub PTR_SUB () { &add;}' unless defined(&PTR_SUB);
	eval 'sub PTR_SUBI () { &subi;}' unless defined(&PTR_SUBI);
	eval 'sub PTR_SUBU () { &subu;}' unless defined(&PTR_SUBU);
	eval 'sub PTR_SUBIU () { &subu;}' unless defined(&PTR_SUBIU);
	eval 'sub PTR_L () { &lw;}' unless defined(&PTR_L);
	eval 'sub PTR_S () { &sw;}' unless defined(&PTR_S);
	eval 'sub PTR_SLL () { &sll;}' unless defined(&PTR_SLL);
	eval 'sub PTR_SLLV () { &sllv;}' unless defined(&PTR_SLLV);
	eval 'sub PTR_SRL () { &srl;}' unless defined(&PTR_SRL);
	eval 'sub PTR_SRLV () { &srlv;}' unless defined(&PTR_SRLV);
	eval 'sub PTR_SRA () { &sra;}' unless defined(&PTR_SRA);
	eval 'sub PTR_SRAV () { &srav;}' unless defined(&PTR_SRAV);
	eval 'sub PTR_SCALESHIFT () {2;}' unless defined(&PTR_SCALESHIFT);
    }
    if(((defined(&_MIPS_SZLONG) ? &_MIPS_SZLONG : 0) == 64)) {
	eval 'sub PTR_ADD () { &dadd;}' unless defined(&PTR_ADD);
	eval 'sub PTR_ADDI () { &daddi;}' unless defined(&PTR_ADDI);
	eval 'sub PTR_ADDU () { &daddu;}' unless defined(&PTR_ADDU);
	eval 'sub PTR_ADDIU () { &daddiu;}' unless defined(&PTR_ADDIU);
	eval 'sub PTR_SUB () { &dadd;}' unless defined(&PTR_SUB);
	eval 'sub PTR_SUBI () { &dsubi;}' unless defined(&PTR_SUBI);
	eval 'sub PTR_SUBU () { &dsubu;}' unless defined(&PTR_SUBU);
	eval 'sub PTR_SUBIU () { &dsubu;}' unless defined(&PTR_SUBIU);
	eval 'sub PTR_L () { &ld;}' unless defined(&PTR_L);
	eval 'sub PTR_S () { &sd;}' unless defined(&PTR_S);
	eval 'sub PTR_SLL () { &dsll;}' unless defined(&PTR_SLL);
	eval 'sub PTR_SLLV () { &dsllv;}' unless defined(&PTR_SLLV);
	eval 'sub PTR_SRL () { &dsrl;}' unless defined(&PTR_SRL);
	eval 'sub PTR_SRLV () { &dsrlv;}' unless defined(&PTR_SRLV);
	eval 'sub PTR_SRA () { &dsra;}' unless defined(&PTR_SRA);
	eval 'sub PTR_SRAV () { &dsrav;}' unless defined(&PTR_SRAV);
	eval 'sub PTR_SCALESHIFT () {3;}' unless defined(&PTR_SCALESHIFT);
    }
    if(((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS1) ? &_MIPS_ISA_MIPS1 : 0)) || ((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS2) ? &_MIPS_ISA_MIPS2 : 0))) {
	eval 'sub MFC0 () { &mfc0;}' unless defined(&MFC0);
	eval 'sub MTC0 () { &mtc0;}' unless defined(&MTC0);
    }
    if(((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS3) ? &_MIPS_ISA_MIPS3 : 0)) || ((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS4) ? &_MIPS_ISA_MIPS4 : 0)) || ((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS5) ? &_MIPS_ISA_MIPS5 : 0))) {
	eval 'sub MFC0 () { &dmfc0;}' unless defined(&MFC0);
	eval 'sub MTC0 () { &dmtc0;}' unless defined(&MTC0);
    }
}
1;
