require '_h2ph_pre.ph';

unless(defined(&_MC146818RTC_H)) {
    eval 'sub _MC146818RTC_H () {1;}' unless defined(&_MC146818RTC_H);
    require 'asm/mc146818rtc.ph';
    eval 'sub RTC_HUNDREDTH_SECOND () {0;}' unless defined(&RTC_HUNDREDTH_SECOND);
    eval 'sub RTC_SECONDS () {1;}' unless defined(&RTC_SECONDS);
    eval 'sub RTC_MINUTES () {2;}' unless defined(&RTC_MINUTES);
    eval 'sub RTC_MINUTES_ALARM () {3;}' unless defined(&RTC_MINUTES_ALARM);
    eval 'sub RTC_HOURS () {4;}' unless defined(&RTC_HOURS);
    eval 'sub RTC_HOURS_ALARM () {5;}' unless defined(&RTC_HOURS_ALARM);
    eval 'sub RTC_DAY () {6;}' unless defined(&RTC_DAY);
    eval 'sub RTC_DAY_ALARM () {7;}' unless defined(&RTC_DAY_ALARM);
    eval 'sub RTC_DATE () {8;}' unless defined(&RTC_DATE);
    eval 'sub RTC_MONTH () {9;}' unless defined(&RTC_MONTH);
    eval 'sub RTC_YEAR () {10;}' unless defined(&RTC_YEAR);
    eval 'sub RTC_CMD () {11;}' unless defined(&RTC_CMD);
    eval 'sub RTC_WHSEC () {12;}' unless defined(&RTC_WHSEC);
    eval 'sub RTC_WSEC () {13;}' unless defined(&RTC_WSEC);
    eval 'sub RTC_UNUSED () {14;}' unless defined(&RTC_UNUSED);
    eval 'sub RTC_ALARM_DONT_CARE () {0xc0;}' unless defined(&RTC_ALARM_DONT_CARE);
    eval 'sub RTC_EOSC () {0x80;}' unless defined(&RTC_EOSC);
    eval 'sub RTC_ESQW () {0x40;}' unless defined(&RTC_ESQW);
    eval 'sub RTC_TDF () {0x01;}' unless defined(&RTC_TDF);
    eval 'sub RTC_WAF () {0x02;}' unless defined(&RTC_WAF);
    eval 'sub RTC_TDM () {0x04;}' unless defined(&RTC_TDM);
    eval 'sub RTC_WAM () {0x08;}' unless defined(&RTC_WAM);
    eval 'sub RTC_PU_LVL () {0x10;}' unless defined(&RTC_PU_LVL);
    eval 'sub RTC_IBH_LO () {0x20;}' unless defined(&RTC_IBH_LO);
    eval 'sub RTC_IPSW () {0x40;}' unless defined(&RTC_IPSW);
    eval 'sub RTC_TE () {0x80;}' unless defined(&RTC_TE);
    unless(defined(&BCD_TO_BIN)) {
	eval 'sub BCD_TO_BIN {
	    local($val) = @_;
    	    eval q((($val)=(($val)&15) + (($val)>>4)*10));
	}' unless defined(&BCD_TO_BIN);
    }
    unless(defined(&BIN_TO_BCD)) {
	eval 'sub BIN_TO_BCD {
	    local($val) = @_;
    	    eval q((($val)=((($val)/10)<<4) + ($val)%10));
	}' unless defined(&BIN_TO_BCD);
    }
}
1;
