require '_h2ph_pre.ph';

unless(defined(&__ASM_MIPS_ELF_H)) {
    eval 'sub __ASM_MIPS_ELF_H () {1;}' unless defined(&__ASM_MIPS_ELF_H);
    eval 'sub ELF_NGREG () {45;}' unless defined(&ELF_NGREG);
    eval 'sub ELF_NFPREG () {33;}' unless defined(&ELF_NFPREG);
    eval 'sub elf_check_arch {
        local($x) = @_;
	    eval q((($x) ==  &EM_MIPS || ($x) ==  &EM_MIPS_RS4_BE));
    }' unless defined(&elf_check_arch);
    eval 'sub ELF_CLASS () { &ELFCLASS32;}' unless defined(&ELF_CLASS);
    if(defined(&__MIPSEB__)) {
	eval 'sub ELF_DATA () { &ELFDATA2MSB;}' unless defined(&ELF_DATA);
    }
 elsif((defined(&__MIPSEL__) ? &__MIPSEL__ : 0)) {
	eval 'sub ELF_DATA () { &ELFDATA2LSB;}' unless defined(&ELF_DATA);
    }
    eval 'sub ELF_ARCH () { &EM_MIPS;}' unless defined(&ELF_ARCH);
    eval 'sub USE_ELF_CORE_DUMP () {1;}' unless defined(&USE_ELF_CORE_DUMP);
    eval 'sub ELF_EXEC_PAGESIZE () {4096;}' unless defined(&ELF_EXEC_PAGESIZE);
    eval 'sub ELF_CORE_COPY_REGS {
        local($_dest,$_regs) = @_;
	    eval q( &memcpy( &$_dest, $_regs, $sizeof{\'struct pt_regs\'}););
    }' unless defined(&ELF_CORE_COPY_REGS);
    eval 'sub ELF_HWCAP () {(0);}' unless defined(&ELF_HWCAP);
    eval 'sub ELF_PLATFORM () {( &NULL);}' unless defined(&ELF_PLATFORM);
    eval 'sub ELF_PLAT_INIT {
        local($_r) = @_;
	    eval q( &do {  ($_r->{regs[1]}) =  ($_r->{regs[2]}) =  ($_r->{regs[3]}) =  ($_r->{regs[4]}) = 0;  ($_r->{regs[5]}) =  ($_r->{regs[6]}) =  ($_r->{regs[7]}) =  ($_r->{regs[8]}) = 0;  ($_r->{regs[9]}) =  ($_r->{regs[10]}) =  ($_r->{regs[11]}) =  ($_r->{regs[12]}) = 0;  ($_r->{regs[13]}) =  ($_r->{regs[14]}) =  ($_r->{regs[15]}) =  ($_r->{regs[16]}) = 0;  ($_r->{regs[17]}) =  ($_r->{regs[18]}) =  ($_r->{regs[19]}) =  ($_r->{regs[20]}) = 0;  ($_r->{regs[21]}) =  ($_r->{regs[22]}) =  ($_r->{regs[23]}) =  ($_r->{regs[24]}) = 0;  ($_r->{regs[25]}) =  ($_r->{regs[26]}) =  ($_r->{regs[27]}) =  ($_r->{regs[28]}) = 0;  ($_r->{regs[30]}) =  ($_r->{regs[31]}) = 0; }  &while (0));
    }' unless defined(&ELF_PLAT_INIT);
    eval 'sub ELF_ET_DYN_BASE () {(2*  &TASK_SIZE / 3);}' unless defined(&ELF_ET_DYN_BASE);
    if(defined(&__KERNEL__)) {
	eval 'sub SET_PERSONALITY {
	    local($ex,$ibcs2) = @_;
    	    eval q( ($current->{personality}) = ($ibcs2 ?  &PER_SVR4 :  &PER_LINUX));
	}' unless defined(&SET_PERSONALITY);
    }
}
1;
