require '_h2ph_pre.ph';

unless(defined(&__ASM_MIPS_FLOPPY_H)) {
    eval 'sub __ASM_MIPS_FLOPPY_H () {1;}' unless defined(&__ASM_MIPS_FLOPPY_H);
    require 'asm/bootinfo.ph';
    require 'asm/jazz.ph';
    require 'asm/jazzdma.ph';
    require 'asm/mipsconfig.ph';
    eval 'sub fd_inb {
        local($port) = @_;
	    eval q( ($fd_ops->{fd_inb})($port));
    }' unless defined(&fd_inb);
    eval 'sub fd_outb {
        local($value,$port) = @_;
	    eval q( ($fd_ops->{fd_outb})($value,$port));
    }' unless defined(&fd_outb);
    eval 'sub fd_enable_dma {
        local($channel) = @_;
	    eval q( ($fd_ops->{fd_enable_dma})($channel));
    }' unless defined(&fd_enable_dma);
    eval 'sub fd_disable_dma {
        local($channel) = @_;
	    eval q( ($fd_ops->{fd_disable_dma})($channel));
    }' unless defined(&fd_disable_dma);
    eval 'sub fd_request_dma {
        local($channel) = @_;
	    eval q( ($fd_ops->{fd_request_dma})($channel));
    }' unless defined(&fd_request_dma);
    eval 'sub fd_free_dma {
        local($channel) = @_;
	    eval q( ($fd_ops->{fd_free_dma})($channel));
    }' unless defined(&fd_free_dma);
    eval 'sub fd_clear_dma_ff {
        local($channel) = @_;
	    eval q( ($fd_ops->{fd_clear_dma_ff})($channel));
    }' unless defined(&fd_clear_dma_ff);
    eval 'sub fd_set_dma_mode {
        local($channel, $mode) = @_;
	    eval q( ($fd_ops->{fd_set_dma_mode})($channel, $mode));
    }' unless defined(&fd_set_dma_mode);
    eval 'sub fd_set_dma_addr {
        local($channel, $addr) = @_;
	    eval q( ($fd_ops->{fd_set_dma_addr})($channel,  &virt_to_bus($addr)));
    }' unless defined(&fd_set_dma_addr);
    eval 'sub fd_set_dma_count {
        local($channel,$count) = @_;
	    eval q( ($fd_ops->{fd_set_dma_count})($channel,$count));
    }' unless defined(&fd_set_dma_count);
    eval 'sub fd_get_dma_residue {
        local($channel) = @_;
	    eval q( ($fd_ops->{fd_get_dma_residue})($channel));
    }' unless defined(&fd_get_dma_residue);
    eval 'sub fd_enable_irq {
        local($irq) = @_;
	    eval q( ($fd_ops->{fd_enable_irq})($irq));
    }' unless defined(&fd_enable_irq);
    eval 'sub fd_disable_irq {
        local($irq) = @_;
	    eval q( ($fd_ops->{fd_disable_irq})($irq));
    }' unless defined(&fd_disable_irq);
    eval 'sub fd_request_irq {
        local($irq) = @_;
	    eval q( &request_irq($irq,  &floppy_interrupt,  &SA_INTERRUPT |  &SA_SAMPLE_RANDOM, \\"floppy\\",  &NULL));
    }' unless defined(&fd_request_irq);
    eval 'sub fd_free_irq {
        local($irq) = @_;
	    eval q( &free_irq($irq,  &NULL););
    }' unless defined(&fd_free_irq);
    eval 'sub fd_dma_mem_alloc {
        local($size) = @_;
	    eval q( ($fd_ops->{fd_dma_mem_alloc})($size));
    }' unless defined(&fd_dma_mem_alloc);
    eval 'sub fd_dma_mem_free {
        local($mem,$size) = @_;
	    eval q( ($fd_ops->{fd_dma_mem_free})($mem,$size));
    }' unless defined(&fd_dma_mem_free);
    eval 'sub fd_drive_type {
        local($n) = @_;
	    eval q( ($fd_ops->{fd_drive_type})($n));
    }' unless defined(&fd_drive_type);
    eval 'sub MAX_BUFFER_SECTORS () {24;}' unless defined(&MAX_BUFFER_SECTORS);
    eval 'sub FLOPPY0_TYPE () { &fd_drive_type(0);}' unless defined(&FLOPPY0_TYPE);
    eval 'sub FLOPPY1_TYPE () { &fd_drive_type(1);}' unless defined(&FLOPPY1_TYPE);
    eval 'sub FDC1 () { ($fd_ops->{fd_getfdaddr1})();;}' unless defined(&FDC1);
    eval 'sub N_FDC () {1;}' unless defined(&N_FDC);
    eval 'sub N_DRIVE () {8;}' unless defined(&N_DRIVE);
    eval 'sub FLOPPY_MOTOR_MASK () {0xf0;}' unless defined(&FLOPPY_MOTOR_MASK);
    eval 'sub CROSS_64KB {
        local($a,$s) = @_;
	    eval q((/ &K_64 != (($a) + ($s) - 1) /  &K_64));
    }' unless defined(&CROSS_64KB);
}
1;
