require '_h2ph_pre.ph';

unless(defined(&__ASM_MIPS_IO_H)) {
    eval 'sub __ASM_MIPS_IO_H () {1;}' unless defined(&__ASM_MIPS_IO_H);
    undef(&CONF_SLOWDOWN_IO) if defined(&CONF_SLOWDOWN_IO);
    require 'asm/mipsconfig.ph';
    require 'asm/addrspace.ph';
    eval 'sub __SLOW_DOWN_IO () { &__asm__  &__volatile__( "sb\\t$0,0x80(%0)" : : "r" ( &mips_io_port_base));;}' unless defined(&__SLOW_DOWN_IO);
    if(defined(&CONF_SLOWDOWN_IO)) {
	if(defined(&REALLY_SLOW_IO)) {
	    eval 'sub SLOW_DOWN_IO () {{  &__SLOW_DOWN_IO;  &__SLOW_DOWN_IO;  &__SLOW_DOWN_IO;  &__SLOW_DOWN_IO; };}' unless defined(&SLOW_DOWN_IO);
	} else {
	    eval 'sub SLOW_DOWN_IO () { &__SLOW_DOWN_IO;}' unless defined(&SLOW_DOWN_IO);
	}
    } else {
	eval 'sub SLOW_DOWN_IO () {1;}' unless defined(&SLOW_DOWN_IO);
    }
    eval 'sub readb {
        local($addr) = @_;
	    eval q((* (0xa0000000 + ($addr))));
    }' unless defined(&readb);
    eval 'sub readw {
        local($addr) = @_;
	    eval q((* (0xa0000000 + ($addr))));
    }' unless defined(&readw);
    eval 'sub readl {
        local($addr) = @_;
	    eval q((* (0xa0000000 + ($addr))));
    }' unless defined(&readl);
    eval 'sub writeb {
        local($b,$addr) = @_;
	    eval q((* (0xa0000000 + ($addr)) = ($b)));
    }' unless defined(&writeb);
    eval 'sub writew {
        local($b,$addr) = @_;
	    eval q((* (0xa0000000 + ($addr)) = ($b)));
    }' unless defined(&writew);
    eval 'sub writel {
        local($b,$addr) = @_;
	    eval q((* (0xa0000000 + ($addr)) = ($b)));
    }' unless defined(&writel);
    eval 'sub memset_io {
        local($a,$b,$c) = @_;
	    eval q( &memset((0xa0000000 + $a),($b),($c)));
    }' unless defined(&memset_io);
    eval 'sub memcpy_fromio {
        local($a,$b,$c) = @_;
	    eval q( &memcpy(,(0xa0000000 + ($b)),($c)));
    }' unless defined(&memcpy_fromio);
    eval 'sub memcpy_toio {
        local($a,$b,$c) = @_;
	    eval q( &memcpy((0xa0000000 + ($a)),($b),($c)));
    }' unless defined(&memcpy_toio);
    eval 'sub eth_io_copy_and_sum {
        local($skb,$src,$len,$unused) = @_;
	    eval q( &memcpy_fromio(($skb)-> &data,($src),($len)));
    }' unless defined(&eth_io_copy_and_sum);
    eval 'sub __OUT1 {
        local($s) = @_;
	    eval q( &extern  &inline  &void  &__out$s(\'unsigned int value\', \'unsigned int port\') {);
    }' unless defined(&__OUT1);
    eval 'sub __OUT2 {
        local($m) = @_;
	    eval q( &__asm__  &__volatile__ (\\"s\\" $m \\"\\\\t%0,%1(%2)\\");
    }' unless defined(&__OUT2);
    eval 'sub __OUT {
        local($m,$s) = @_;
	    eval q( &__OUT1  &__OUT2($m) : : \\"r\\" ( &value), \\"i\\" (0), \\"r\\" ( &mips_io_port_base+ &port)); }  &__OUT1($s &c)  &__OUT2($m) : : \\"r\\" ( &value), \\"ir\\" ( &port), \\"r\\" ( &mips_io_port_base)); }  &__OUT1($s &_p)  &__OUT2($m) : : \\"r\\" ( &value), \\"i\\" (0), \\"r\\" ( &mips_io_port_base+ &port));  &SLOW_DOWN_IO; }  &__OUT1($s &c_p)  &__OUT2($m) : : \\"r\\" ( &value), \\"ir\\" ( &port), \\"r\\" ( &mips_io_port_base));  &SLOW_DOWN_IO; });
    }' unless defined(&__OUT);
    eval 'sub __IN1 {
        local($t,$s) = @_;
	    eval q( &extern  &__inline__ $t  &__in$s { $t  &_v;);
    }' unless defined(&__IN1);
    eval 'sub __IN2 {
        local($m) = @_;
	    eval q( &__asm__  &__volatile__ (\\"l\\" $m \\"\\\\t%0,%1(%2)\\");
    }' unless defined(&__IN2);
    eval 'sub __IN {
        local($t,$m,$s) = @_;
	    eval q( &__IN1($t,$s)  &__IN2($m) : \\"=r\\" ( &_v) : \\"i\\" (0), \\"r\\" ( &mips_io_port_base+ &port));  &return  &_v; }  &__IN1($t,$s &c)  &__IN2($m) : \\"=r\\" ( &_v) : \\"ir\\" ( &port), \\"r\\" ( &mips_io_port_base));  &return  &_v; }  &__IN1($t,$s &_p)  &__IN2($m) : \\"=r\\" ( &_v) : \\"i\\" (0), \\"r\\" ( &mips_io_port_base+ &port));  &SLOW_DOWN_IO;  &return  &_v; }  &__IN1($t,$s &c_p)  &__IN2($m) : \\"=r\\" ( &_v) : \\"ir\\" ( &port), \\"r\\" ( &mips_io_port_base));  &SLOW_DOWN_IO;  &return  &_v; });
    }' unless defined(&__IN);
    eval 'sub __INS1 {
        local($s) = @_;
	    eval q( &extern  &inline  &void  &__ins$s(\'unsigned int port\',  &void *  &addr, \'unsigned long count\') {);
    }' unless defined(&__INS1);
    eval 'sub __INS2 {
        local($m) = @_;
	    eval q( &if  &__asm__  &__volatile__ ( \\".set\\\\tnoreorder\\\\n\\\\t\\" \\".set\\\\tnoat\\\\n\\" \\"1:\\\\tl\\" $m \\"\\\\t$1,%4(%5)\\\\n\\\\t\\" \\"subu\\\\t%1,1\\\\n\\\\t\\" \\"s\\" $m \\"\\\\t$1,(%0)\\\\n\\\\t\\" \\"bne\\\\t$0,%1,1b\\\\n\\\\t\\" \\"addiu\\\\t%0,%6\\\\n\\\\t\\" \\".set\\\\tat\\\\n\\\\t\\" \\".set\\\\treorder\\");
    }' unless defined(&__INS2);
    eval 'sub __INS {
        local($m,$s,$i) = @_;
	    eval q( &__INS1  &__INS2($m) : \\"=r\\" ( &addr), \\"=r\\" ( &count) : \\"0\\" ( &addr), \\"1\\" ( &count), \\"i\\" (0), \\"r\\" ( &mips_io_port_base+ &port), \\"I\\" ($i) : \\"$1\\");}  &__INS1($s &c)  &__INS2($m) : \\"=r\\" ( &addr), \\"=r\\" ( &count) : \\"0\\" ( &addr), \\"1\\" ( &count), \\"ir\\" ( &port), \\"r\\" ( &mips_io_port_base), \\"I\\" ($i) : \\"$1\\");});
    }' unless defined(&__INS);
    eval 'sub __OUTS1 {
        local($s) = @_;
	    eval q( &extern  &inline  &void  &__outs$s(\'unsigned int port\',  &const  &void *  &addr, \'unsigned long count\') {);
    }' unless defined(&__OUTS1);
    eval 'sub __OUTS2 {
        local($m) = @_;
	    eval q( &if  &__asm__  &__volatile__ ( \\".set\\\\tnoreorder\\\\n\\\\t\\" \\".set\\\\tnoat\\\\n\\" \\"1:\\\\tl\\" $m \\"\\\\t$1,(%0)\\\\n\\\\t\\" \\"subu\\\\t%1,1\\\\n\\\\t\\" \\"s\\" $m \\"\\\\t$1,%4(%5)\\\\n\\\\t\\" \\"bne\\\\t$0,%1,1b\\\\n\\\\t\\" \\"addiu\\\\t%0,%6\\\\n\\\\t\\" \\".set\\\\tat\\\\n\\\\t\\" \\".set\\\\treorder\\");
    }' unless defined(&__OUTS2);
    eval 'sub __OUTS {
        local($m,$s,$i) = @_;
	    eval q( &__OUTS1  &__OUTS2($m) : \\"=r\\" ( &addr), \\"=r\\" ( &count) : \\"0\\" ( &addr), \\"1\\" ( &count), \\"i\\" (0), \\"r\\" ( &mips_io_port_base+ &port), \\"I\\" ($i) : \\"$1\\");}  &__OUTS1($s &c)  &__OUTS2($m) : \\"=r\\" ( &addr), \\"=r\\" ( &count) : \\"0\\" ( &addr), \\"1\\" ( &count), \\"ir\\" ( &port), \\"r\\" ( &mips_io_port_base), \\"I\\" ($i) : \\"$1\\");});
    }' unless defined(&__OUTS);
    eval 'sub outb {
        local($val,$port) = @_;
	    eval q((( &__builtin_constant_p(($port))  && ($port) < 32768) ?  &__outbc(($val),($port)) :  &__outb(($val),($port))));
    }' unless defined(&outb);
    eval 'sub inb {
        local($port) = @_;
	    eval q((( &__builtin_constant_p(($port))  && ($port) < 32768) ?  &__inbc($port) :  &__inb($port)));
    }' unless defined(&inb);
    eval 'sub outb_p {
        local($val,$port) = @_;
	    eval q((( &__builtin_constant_p(($port))  && ($port) < 32768) ?  &__outbc_p(($val),($port)) :  &__outb_p(($val),($port))));
    }' unless defined(&outb_p);
    eval 'sub inb_p {
        local($port) = @_;
	    eval q((( &__builtin_constant_p(($port))  && ($port) < 32768) ?  &__inbc_p($port) :  &__inb_p($port)));
    }' unless defined(&inb_p);
    eval 'sub outw {
        local($val,$port) = @_;
	    eval q((( &__builtin_constant_p(($port))  && ($port) < 32768) ?  &__outwc(($val),($port)) :  &__outw(($val),($port))));
    }' unless defined(&outw);
    eval 'sub inw {
        local($port) = @_;
	    eval q((( &__builtin_constant_p(($port))  && ($port) < 32768) ?  &__inwc($port) :  &__inw($port)));
    }' unless defined(&inw);
    eval 'sub outw_p {
        local($val,$port) = @_;
	    eval q((( &__builtin_constant_p(($port))  && ($port) < 32768) ?  &__outwc_p(($val),($port)) :  &__outw_p(($val),($port))));
    }' unless defined(&outw_p);
    eval 'sub inw_p {
        local($port) = @_;
	    eval q((( &__builtin_constant_p(($port))  && ($port) < 32768) ?  &__inwc_p($port) :  &__inw_p($port)));
    }' unless defined(&inw_p);
    eval 'sub outl {
        local($val,$port) = @_;
	    eval q((( &__builtin_constant_p(($port))  && ($port) < 32768) ?  &__outlc(($val),($port)) :  &__outl(($val),($port))));
    }' unless defined(&outl);
    eval 'sub inl {
        local($port) = @_;
	    eval q((( &__builtin_constant_p(($port))  && ($port) < 32768) ?  &__inlc($port) :  &__inl($port)));
    }' unless defined(&inl);
    eval 'sub outl_p {
        local($val,$port) = @_;
	    eval q((( &__builtin_constant_p(($port))  && ($port) < 32768) ?  &__outlc_p(($val),($port)) :  &__outl_p(($val),($port))));
    }' unless defined(&outl_p);
    eval 'sub inl_p {
        local($port) = @_;
	    eval q((( &__builtin_constant_p(($port))  && ($port) < 32768) ?  &__inlc_p($port) :  &__inl_p($port)));
    }' unless defined(&inl_p);
    eval 'sub outsb {
        local($port,$addr,$count) = @_;
	    eval q((( &__builtin_constant_p(($port))  && ($port) < 32768) ?  &__outsbc(($port),($addr),($count)) :  &__outsb (($port),($addr),($count))));
    }' unless defined(&outsb);
    eval 'sub insb {
        local($port,$addr,$count) = @_;
	    eval q((( &__builtin_constant_p(($port))  && ($port) < 32768) ?  &__insbc(($port),($addr),($count)) :  &__insb(($port),($addr),($count))));
    }' unless defined(&insb);
    eval 'sub outsw {
        local($port,$addr,$count) = @_;
	    eval q((( &__builtin_constant_p(($port))  && ($port) < 32768) ?  &__outswc(($port),($addr),($count)) :  &__outsw (($port),($addr),($count))));
    }' unless defined(&outsw);
    eval 'sub insw {
        local($port,$addr,$count) = @_;
	    eval q((( &__builtin_constant_p(($port))  && ($port) < 32768) ?  &__inswc(($port),($addr),($count)) :  &__insw(($port),($addr),($count))));
    }' unless defined(&insw);
    eval 'sub outsl {
        local($port,$addr,$count) = @_;
	    eval q((( &__builtin_constant_p(($port))  && ($port) < 32768) ?  &__outslc(($port),($addr),($count)) :  &__outsl (($port),($addr),($count))));
    }' unless defined(&outsl);
    eval 'sub insl {
        local($port,$addr,$count) = @_;
	    eval q((( &__builtin_constant_p(($port))  && ($port) < 32768) ?  &__inslc(($port),($addr),($count)) :  &__insl(($port),($addr),($count))));
    }' unless defined(&insl);
}
1;
