require '_h2ph_pre.ph';

unless(defined(&__ASM_MIPS_JAZZDMA_H)) {
    eval 'sub __ASM_MIPS_JAZZDMA_H () {1;}' unless defined(&__ASM_MIPS_JAZZDMA_H);
    eval 'sub VDMA_PAGESIZE () {4096;}' unless defined(&VDMA_PAGESIZE);
    eval 'sub VDMA_PGTBL_ENTRIES () {4096;}' unless defined(&VDMA_PGTBL_ENTRIES);
    eval 'sub VDMA_PGTBL_SIZE () {($sizeof{ &VDMA_PGTBL_ENTRY} *  &VDMA_PGTBL_ENTRIES);}' unless defined(&VDMA_PGTBL_SIZE);
    eval 'sub VDMA_PAGE_EMPTY () {0xff000000;}' unless defined(&VDMA_PAGE_EMPTY);
    eval 'sub VDMA_PAGE {
        local($a) = @_;
	    eval q((($a) >> 12));
    }' unless defined(&VDMA_PAGE);
    eval 'sub VDMA_OFFSET {
        local($a) = @_;
	    eval q((($a) & ( &VDMA_PAGESIZE-1)));
    }' unless defined(&VDMA_OFFSET);
    eval 'sub VDMA_ERROR () {0xffffffff;}' unless defined(&VDMA_ERROR);
    eval 'sub JAZZ_R4030_CHNL_MODE () {0xe0000100;}' unless defined(&JAZZ_R4030_CHNL_MODE);
    eval 'sub JAZZ_R4030_CHNL_ENABLE () {0xe0000108;}' unless defined(&JAZZ_R4030_CHNL_ENABLE);
    eval 'sub JAZZ_R4030_CHNL_COUNT () {0xe0000110;}' unless defined(&JAZZ_R4030_CHNL_COUNT);
    eval 'sub JAZZ_R4030_CHNL_ADDR () {0xe0000118;}' unless defined(&JAZZ_R4030_CHNL_ADDR);
    eval 'sub R4030_CHNL_ENABLE () {(1<<0);}' unless defined(&R4030_CHNL_ENABLE);
    eval 'sub R4030_CHNL_WRITE () {(1<<1);}' unless defined(&R4030_CHNL_WRITE);
    eval 'sub R4030_TC_INTR () {(1<<8);}' unless defined(&R4030_TC_INTR);
    eval 'sub R4030_MEM_INTR () {(1<<9);}' unless defined(&R4030_MEM_INTR);
    eval 'sub R4030_ADDR_INTR () {(1<<10);}' unless defined(&R4030_ADDR_INTR);
    eval 'sub R4030_MODE_ATIME_40 () {(0);}' unless defined(&R4030_MODE_ATIME_40);
    eval 'sub R4030_MODE_ATIME_80 () {(1);}' unless defined(&R4030_MODE_ATIME_80);
    eval 'sub R4030_MODE_ATIME_120 () {(2);}' unless defined(&R4030_MODE_ATIME_120);
    eval 'sub R4030_MODE_ATIME_160 () {(3);}' unless defined(&R4030_MODE_ATIME_160);
    eval 'sub R4030_MODE_ATIME_200 () {(4);}' unless defined(&R4030_MODE_ATIME_200);
    eval 'sub R4030_MODE_ATIME_240 () {(5);}' unless defined(&R4030_MODE_ATIME_240);
    eval 'sub R4030_MODE_ATIME_280 () {(6);}' unless defined(&R4030_MODE_ATIME_280);
    eval 'sub R4030_MODE_ATIME_320 () {(7);}' unless defined(&R4030_MODE_ATIME_320);
    eval 'sub R4030_MODE_WIDTH_8 () {(1<<3);}' unless defined(&R4030_MODE_WIDTH_8);
    eval 'sub R4030_MODE_WIDTH_16 () {(2<<3);}' unless defined(&R4030_MODE_WIDTH_16);
    eval 'sub R4030_MODE_WIDTH_32 () {(3<<3);}' unless defined(&R4030_MODE_WIDTH_32);
    eval 'sub R4030_MODE_INTR_EN () {(1<<5);}' unless defined(&R4030_MODE_INTR_EN);
    eval 'sub R4030_MODE_BURST () {(1<<6);}' unless defined(&R4030_MODE_BURST);
    eval 'sub R4030_MODE_FAST_ACK () {(1<<7);}' unless defined(&R4030_MODE_FAST_ACK);
}
1;
