require '_h2ph_pre.ph';

unless(defined(&__ASM_MIPS_PGTABLE_H)) {
    eval 'sub __ASM_MIPS_PGTABLE_H () {1;}' unless defined(&__ASM_MIPS_PGTABLE_H);
    require 'asm/addrspace.ph';
    require 'asm/mipsconfig.ph';
    unless(defined(&_LANGUAGE_ASSEMBLY)) {
	require 'linux/linkage.ph';
	require 'asm/cachectl.ph';
	eval 'sub flush_icache_range {
	    local($start, $end) = @_;
    	    eval q( &flush_cache_all());
	}' unless defined(&flush_icache_range);
    }
    eval 'sub PMD_SHIFT () {22;}' unless defined(&PMD_SHIFT);
    eval 'sub PMD_SIZE () {(1 <<  &PMD_SHIFT);}' unless defined(&PMD_SIZE);
    eval 'sub PMD_MASK () {(~( &PMD_SIZE-1));}' unless defined(&PMD_MASK);
    eval 'sub PGDIR_SHIFT () {22;}' unless defined(&PGDIR_SHIFT);
    eval 'sub PGDIR_SIZE () {(1 <<  &PGDIR_SHIFT);}' unless defined(&PGDIR_SIZE);
    eval 'sub PGDIR_MASK () {(~( &PGDIR_SIZE-1));}' unless defined(&PGDIR_MASK);
    eval 'sub PTRS_PER_PTE () {1024;}' unless defined(&PTRS_PER_PTE);
    eval 'sub PTRS_PER_PMD () {1;}' unless defined(&PTRS_PER_PMD);
    eval 'sub PTRS_PER_PGD () {1024;}' unless defined(&PTRS_PER_PGD);
    eval 'sub USER_PTRS_PER_PGD () {( &TASK_SIZE/ &PGDIR_SIZE);}' unless defined(&USER_PTRS_PER_PGD);
    eval 'sub VMALLOC_START () { &KSEG2;}' unless defined(&VMALLOC_START);
    eval 'sub VMALLOC_VMADDR {
        local($x) = @_;
	    eval q((($x)));
    }' unless defined(&VMALLOC_VMADDR);
    eval 'sub VMALLOC_END () { &KSEG3;}' unless defined(&VMALLOC_END);
    eval 'sub _PAGE_PRESENT () {(1<<0);}' unless defined(&_PAGE_PRESENT);
    eval 'sub _PAGE_READ () {(1<<1);}' unless defined(&_PAGE_READ);
    eval 'sub _PAGE_WRITE () {(1<<2);}' unless defined(&_PAGE_WRITE);
    eval 'sub _PAGE_ACCESSED () {(1<<3);}' unless defined(&_PAGE_ACCESSED);
    eval 'sub _PAGE_MODIFIED () {(1<<4);}' unless defined(&_PAGE_MODIFIED);
    eval 'sub _PAGE_R4KBUG () {(1<<5);}' unless defined(&_PAGE_R4KBUG);
    eval 'sub _PAGE_GLOBAL () {(1<<6);}' unless defined(&_PAGE_GLOBAL);
    eval 'sub _PAGE_VALID () {(1<<7);}' unless defined(&_PAGE_VALID);
    eval 'sub _PAGE_SILENT_READ () {(1<<7);}' unless defined(&_PAGE_SILENT_READ);
    eval 'sub _PAGE_DIRTY () {(1<<8);}' unless defined(&_PAGE_DIRTY);
    eval 'sub _PAGE_SILENT_WRITE () {(1<<8);}' unless defined(&_PAGE_SILENT_WRITE);
    eval 'sub _CACHE_CACHABLE_NO_WA () {(0<<9);}' unless defined(&_CACHE_CACHABLE_NO_WA);
    eval 'sub _CACHE_CACHABLE_WA () {(1<<9);}' unless defined(&_CACHE_CACHABLE_WA);
    eval 'sub _CACHE_UNCACHED () {(2<<9);}' unless defined(&_CACHE_UNCACHED);
    eval 'sub _CACHE_CACHABLE_NONCOHERENT () {(3<<9);}' unless defined(&_CACHE_CACHABLE_NONCOHERENT);
    eval 'sub _CACHE_CACHABLE_CE () {(4<<9);}' unless defined(&_CACHE_CACHABLE_CE);
    eval 'sub _CACHE_CACHABLE_COW () {(5<<9);}' unless defined(&_CACHE_CACHABLE_COW);
    eval 'sub _CACHE_CACHABLE_CUW () {(6<<9);}' unless defined(&_CACHE_CACHABLE_CUW);
    eval 'sub _CACHE_CACHABLE_ACCELERATED () {(7<<9);}' unless defined(&_CACHE_CACHABLE_ACCELERATED);
    eval 'sub _CACHE_MASK () {(7<<9);}' unless defined(&_CACHE_MASK);
    eval 'sub __READABLE () {( &_PAGE_READ |  &_PAGE_SILENT_READ |  &_PAGE_ACCESSED);}' unless defined(&__READABLE);
    eval 'sub __WRITEABLE () {( &_PAGE_WRITE |  &_PAGE_SILENT_WRITE |  &_PAGE_MODIFIED);}' unless defined(&__WRITEABLE);
    eval 'sub _PAGE_CHG_MASK () {( &PAGE_MASK |  &_PAGE_ACCESSED |  &_PAGE_MODIFIED |  &_CACHE_MASK);}' unless defined(&_PAGE_CHG_MASK);
    eval 'sub PAGE_NONE () { &__pgprot( &_PAGE_PRESENT |  &_CACHE_CACHABLE_NONCOHERENT);}' unless defined(&PAGE_NONE);
    eval 'sub PAGE_SHARED () { &__pgprot( &_PAGE_PRESENT |  &_PAGE_READ |  &_PAGE_WRITE |  &_CACHE_CACHABLE_NONCOHERENT);}' unless defined(&PAGE_SHARED);
    eval 'sub PAGE_COPY () { &__pgprot( &_PAGE_PRESENT |  &_PAGE_READ |  &_CACHE_CACHABLE_NONCOHERENT);}' unless defined(&PAGE_COPY);
    eval 'sub PAGE_READONLY () { &__pgprot( &_PAGE_PRESENT |  &_PAGE_READ |  &_CACHE_CACHABLE_NONCOHERENT);}' unless defined(&PAGE_READONLY);
    eval 'sub PAGE_KERNEL () { &__pgprot( &_PAGE_PRESENT |  &__READABLE |  &__WRITEABLE |  &_CACHE_CACHABLE_NONCOHERENT);}' unless defined(&PAGE_KERNEL);
    eval 'sub PAGE_USERIO () { &__pgprot( &_PAGE_PRESENT |  &_PAGE_READ |  &_PAGE_WRITE |  &_CACHE_UNCACHED);}' unless defined(&PAGE_USERIO);
    eval 'sub PAGE_KERNEL_UNCACHED () { &__pgprot( &_PAGE_PRESENT |  &__READABLE |  &__WRITEABLE |  &_CACHE_UNCACHED);}' unless defined(&PAGE_KERNEL_UNCACHED);
    eval 'sub __P000 () { &PAGE_NONE;}' unless defined(&__P000);
    eval 'sub __P001 () { &PAGE_READONLY;}' unless defined(&__P001);
    eval 'sub __P010 () { &PAGE_COPY;}' unless defined(&__P010);
    eval 'sub __P011 () { &PAGE_COPY;}' unless defined(&__P011);
    eval 'sub __P100 () { &PAGE_READONLY;}' unless defined(&__P100);
    eval 'sub __P101 () { &PAGE_READONLY;}' unless defined(&__P101);
    eval 'sub __P110 () { &PAGE_COPY;}' unless defined(&__P110);
    eval 'sub __P111 () { &PAGE_COPY;}' unless defined(&__P111);
    eval 'sub __S000 () { &PAGE_NONE;}' unless defined(&__S000);
    eval 'sub __S001 () { &PAGE_READONLY;}' unless defined(&__S001);
    eval 'sub __S010 () { &PAGE_SHARED;}' unless defined(&__S010);
    eval 'sub __S011 () { &PAGE_SHARED;}' unless defined(&__S011);
    eval 'sub __S100 () { &PAGE_READONLY;}' unless defined(&__S100);
    eval 'sub __S101 () { &PAGE_READONLY;}' unless defined(&__S101);
    eval 'sub __S110 () { &PAGE_SHARED;}' unless defined(&__S110);
    eval 'sub __S111 () { &PAGE_SHARED;}' unless defined(&__S111);
    if(!defined ( &_LANGUAGE_ASSEMBLY)) {
	eval 'sub BAD_PAGETABLE () { &__bad_pagetable();}' unless defined(&BAD_PAGETABLE);
	eval 'sub BAD_PAGE () { &__bad_page();}' unless defined(&BAD_PAGE);
	eval 'sub ZERO_PAGE {
	    local($__vaddr) = @_;
    	    eval q(( &empty_zero_page + ((($__vaddr)) &  &zero_page_mask)));
	}' unless defined(&ZERO_PAGE);
	eval 'sub BITS_PER_PTR () {(8*$sizeof{\'unsigned long\'});}' unless defined(&BITS_PER_PTR);
	eval 'sub PTR_MASK () {(~($sizeof{ &void}-1));}' unless defined(&PTR_MASK);
	eval 'sub SIZEOF_PTR_LOG2 () {2;}' unless defined(&SIZEOF_PTR_LOG2);
	eval 'sub PAGE_PTR {
	    local($address) = @_;
    	    eval q((($address)>>( &PAGE_SHIFT- &SIZEOF_PTR_LOG2) &PTR_MASK&~ &PAGE_MASK));
	}' unless defined(&PAGE_PTR);
	eval 'sub SET_PAGE_DIR {
	    local($tsk,$pgdir) = @_;
    	    eval q(-> ($tss->{pg_dir}) = ( ($pgdir)));
	}' unless defined(&SET_PAGE_DIR);
	eval 'sub pgd_offset_k {
	    local($address) = @_;
    	    eval q( &pgd_offset( &init_mm, $address));
	}' unless defined(&pgd_offset_k);
	eval 'sub pgd_quicklist () {( ($current_cpu_data->{pgd_quick}));}' unless defined(&pgd_quicklist);
	eval 'sub pmd_quicklist () {(0);}' unless defined(&pmd_quicklist);
	eval 'sub pte_quicklist () {( ($current_cpu_data->{pte_quick}));}' unless defined(&pte_quicklist);
	eval 'sub pgtable_cache_size () {( ($current_cpu_data->{pgtable_cache_sz}));}' unless defined(&pgtable_cache_size);
	eval 'sub pte_free_kernel {
	    local($pte) = @_;
    	    eval q( &free_pte_fast($pte));
	}' unless defined(&pte_free_kernel);
	eval 'sub pte_free {
	    local($pte) = @_;
    	    eval q( &free_pte_fast($pte));
	}' unless defined(&pte_free);
	eval 'sub pgd_free {
	    local($pgd) = @_;
    	    eval q( &free_pgd_fast($pgd));
	}' unless defined(&pgd_free);
	eval 'sub pgd_alloc () {
	    eval q( &get_pgd_fast());
	}' unless defined(&pgd_alloc);
	eval 'sub pmd_free_kernel () { &pmd_free;}' unless defined(&pmd_free_kernel);
	eval 'sub pmd_alloc_kernel () { &pmd_alloc;}' unless defined(&pmd_alloc_kernel);
	if(defined(&__SMP__)) {
	}
	unless(defined(&__SMP__)) {
	} else {
	}
	eval 'sub SWP_TYPE {
	    local($entry) = @_;
    	    eval q(((($entry) >> 1) & 0x3f));
	}' unless defined(&SWP_TYPE);
	eval 'sub SWP_OFFSET {
	    local($entry) = @_;
    	    eval q((($entry) >> 8));
	}' unless defined(&SWP_OFFSET);
	eval 'sub SWP_ENTRY {
	    local($type,$offset) = @_;
    	    eval q(((($type) << 1) | (($offset) << 8)));
	}' unless defined(&SWP_ENTRY);
	eval 'sub module_map () { &vmalloc;}' unless defined(&module_map);
	eval 'sub module_unmap () { &vfree;}' unless defined(&module_unmap);
	eval 'sub PageSkip {
	    local($page) = @_;
    	    eval q((0));
	}' unless defined(&PageSkip);
	eval 'sub kern_addr_valid {
	    local($addr) = @_;
    	    eval q((1));
	}' unless defined(&kern_addr_valid);
    }
}
1;
