require '_h2ph_pre.ph';

unless(defined(&__ASM_MIPS_PROCESSOR_H)) {
    eval 'sub __ASM_MIPS_PROCESSOR_H () {1;}' unless defined(&__ASM_MIPS_PROCESSOR_H);
    if(!defined ( &_LANGUAGE_ASSEMBLY)) {
	require 'asm/cachectl.ph';
	require 'asm/mipsregs.ph';
	require 'asm/reg.ph';
	require 'asm/system.ph';
	if(defined(&__SMP__)) {
	    eval 'sub current_cpu_data () { $cpu_data[ &smp_processor_id()];}' unless defined(&current_cpu_data);
	} else {
	    eval 'sub cpu_data () { &boot_cpu_data;}' unless defined(&cpu_data);
	    eval 'sub current_cpu_data () { &boot_cpu_data;}' unless defined(&current_cpu_data);
	}
	eval 'sub MCA_bus () {0;}' unless defined(&MCA_bus);
	eval 'sub MCA_bus__is_a_macro () {1;}' unless defined(&MCA_bus__is_a_macro);
	eval 'sub wp_works_ok () {1;}' unless defined(&wp_works_ok);
	eval 'sub wp_works_ok__is_a_macro () {1;}' unless defined(&wp_works_ok__is_a_macro);
	eval 'sub TASK_SIZE () {(0x80000000);}' unless defined(&TASK_SIZE);
	eval 'sub TASK_UNMAPPED_BASE () {( &TASK_SIZE / 3);}' unless defined(&TASK_UNMAPPED_BASE);
	eval 'sub IO_BITMAP_SIZE () {32;}' unless defined(&IO_BITMAP_SIZE);
	eval 'sub NUM_FPU_REGS () {32;}' unless defined(&NUM_FPU_REGS);
	eval 'sub INIT_FPU () {{ {{0,},} };}' unless defined(&INIT_FPU);
	eval 'sub MF_FIXADE () {1;}' unless defined(&MF_FIXADE);
	eval 'sub MF_LOGADE () {2;}' unless defined(&MF_LOGADE);
    }
    eval 'sub INIT_MMAP () {{  &init_mm,  &KSEG0,  &KSEG1,  &NULL,  &PAGE_SHARED,  &VM_READ |  &VM_WRITE |  &VM_EXEC, 1,  &NULL,  &NULL };}' unless defined(&INIT_MMAP);
    eval 'sub INIT_TSS () {{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  &INIT_FPU, 0, 0, 0, 0,  &swapper_pg_dir,  &MF_FIXADE, { 0}, 0, 0};}' unless defined(&INIT_TSS);
    if(defined(&__KERNEL__)) {
	eval 'sub KERNEL_STACK_SIZE () {8192;}' unless defined(&KERNEL_STACK_SIZE);
	if(!defined ( &_LANGUAGE_ASSEMBLY)) {
	    eval 'sub copy_segments {
	        local($nr, $p, $mm) = @_;
    		eval q( &do { }  &while(0));
	    }' unless defined(&copy_segments);
	    eval 'sub release_segments {
	        local($mm) = @_;
    		eval q( &do { }  &while(0));
	    }' unless defined(&release_segments);
	    eval 'sub forget_segments () {
	        eval q( &do { }  &while (0));
	    }' unless defined(&forget_segments);
	    eval 'sub alloc_task_struct () {
	        eval q((  &__get_free_pages( &GFP_KERNEL,1)));
	    }' unless defined(&alloc_task_struct);
	    eval 'sub free_task_struct {
	        local($p) = @_;
    		eval q( &free_pages(($p),1));
	    }' unless defined(&free_task_struct);
	    eval 'sub init_task () {( ($init_task_union->{task}));}' unless defined(&init_task);
	    eval 'sub init_stack () {( ($init_task_union->{stack}));}' unless defined(&init_stack);
	}
    }
    if(((defined(&__GNUC__) ? &__GNUC__ : 0) > 2|| ((defined(&__GNUC__) ? &__GNUC__ : 0) == 2 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) >= 8))) {
	eval 'sub return_address () {
	    eval q(({ &__asm__  &__volatile__(\\"\\":::\\"$31\\"); &__builtin_return_address(0);}));
	}' unless defined(&return_address);
    } else {
	eval 'sub return_address () {
	    eval q( &NULL);
	}' unless defined(&return_address);
    }
}
1;
