require '_h2ph_pre.ph';

unless(defined(&__ASM_MIPS_PTRACE_H)) {
    eval 'sub __ASM_MIPS_PTRACE_H () {1;}' unless defined(&__ASM_MIPS_PTRACE_H);
    require 'linux/types.ph';
    eval 'sub FPR_BASE () {32;}' unless defined(&FPR_BASE);
    eval 'sub PC () {64;}' unless defined(&PC);
    eval 'sub CAUSE () {65;}' unless defined(&CAUSE);
    eval 'sub BADVADDR () {66;}' unless defined(&BADVADDR);
    eval 'sub MMHI () {67;}' unless defined(&MMHI);
    eval 'sub MMLO () {68;}' unless defined(&MMLO);
    eval 'sub FPC_CSR () {69;}' unless defined(&FPC_CSR);
    eval 'sub FPC_EIR () {70;}' unless defined(&FPC_EIR);
    unless(defined(&__ASSEMBLY__)) {
    }
    require 'asm/offset.ph';
    if(defined(&__KERNEL__)) {
	unless(defined(&__ASSEMBLY__)) {
	    eval 'sub user_mode {
	        local($regs) = @_;
    		eval q((($regs)-> &cp0_status & 0x10));
	    }' unless defined(&user_mode);
	    eval 'sub instruction_pointer {
	        local($regs) = @_;
    		eval q((($regs)-> &cp0_epc));
	    }' unless defined(&instruction_pointer);
	}
    }
}
1;
