require '_h2ph_pre.ph';

unless(defined(&_MIPS_R4KCACHE_H)) {
    eval 'sub _MIPS_R4KCACHE_H () {1;}' unless defined(&_MIPS_R4KCACHE_H);
    require 'asm/asm.ph';
    require 'asm/cacheops.ph';
    eval 'sub cache16_unroll32 {
        local($base,$op) = @_;
	    eval q( &__asm__  &__volatile__(\\"							.set noreorder;							.set mips3;							cache %1, 0x000(%0); cache %1, 0x010(%0);			cache %1, 0x020(%0); cache %1, 0x030(%0);			cache %1, 0x040(%0); cache %1, 0x050(%0);			cache %1, 0x060(%0); cache %1, 0x070(%0);			cache %1, 0x080(%0); cache %1, 0x090(%0);			cache %1, 0x0a0(%0); cache %1, 0x0b0(%0);			cache %1, 0x0c0(%0); cache %1, 0x0d0(%0);			cache %1, 0x0e0(%0); cache %1, 0x0f0(%0);			cache %1, 0x100(%0); cache %1, 0x110(%0);			cache %1, 0x120(%0); cache %1, 0x130(%0);			cache %1, 0x140(%0); cache %1, 0x150(%0);			cache %1, 0x160(%0); cache %1, 0x170(%0);			cache %1, 0x180(%0); cache %1, 0x190(%0);			cache %1, 0x1a0(%0); cache %1, 0x1b0(%0);			cache %1, 0x1c0(%0); cache %1, 0x1d0(%0);			cache %1, 0x1e0(%0); cache %1, 0x1f0(%0);			.set mips0;							.set reorder\\" : : \\"r\\" ($base), \\"i\\" ($op)););
    }' unless defined(&cache16_unroll32);
    eval 'sub cache32_unroll32 {
        local($base,$op) = @_;
	    eval q( &__asm__  &__volatile__(\\"							.set noreorder;							.set mips3;							cache %1, 0x000(%0); cache %1, 0x020(%0);			cache %1, 0x040(%0); cache %1, 0x060(%0);			cache %1, 0x080(%0); cache %1, 0x0a0(%0);			cache %1, 0x0c0(%0); cache %1, 0x0e0(%0);			cache %1, 0x100(%0); cache %1, 0x120(%0);			cache %1, 0x140(%0); cache %1, 0x160(%0);			cache %1, 0x180(%0); cache %1, 0x1a0(%0);			cache %1, 0x1c0(%0); cache %1, 0x1e0(%0);			cache %1, 0x200(%0); cache %1, 0x220(%0);			cache %1, 0x240(%0); cache %1, 0x260(%0);			cache %1, 0x280(%0); cache %1, 0x2a0(%0);			cache %1, 0x2c0(%0); cache %1, 0x2e0(%0);			cache %1, 0x300(%0); cache %1, 0x320(%0);			cache %1, 0x340(%0); cache %1, 0x360(%0);			cache %1, 0x380(%0); cache %1, 0x3a0(%0);			cache %1, 0x3c0(%0); cache %1, 0x3e0(%0);			.set mips0;							.set reorder\\" : : \\"r\\" ($base), \\"i\\" ($op)););
    }' unless defined(&cache32_unroll32);
    eval 'sub cache64_unroll32 {
        local($base,$op) = @_;
	    eval q( &__asm__  &__volatile__(\\"							.set noreorder;							.set mips3;							cache %1, 0x000(%0); cache %1, 0x040(%0);			cache %1, 0x080(%0); cache %1, 0x0c0(%0);			cache %1, 0x100(%0); cache %1, 0x140(%0);			cache %1, 0x180(%0); cache %1, 0x1c0(%0);			cache %1, 0x200(%0); cache %1, 0x240(%0);			cache %1, 0x280(%0); cache %1, 0x2c0(%0);			cache %1, 0x300(%0); cache %1, 0x340(%0);			cache %1, 0x380(%0); cache %1, 0x3c0(%0);			cache %1, 0x400(%0); cache %1, 0x440(%0);			cache %1, 0x480(%0); cache %1, 0x4c0(%0);			cache %1, 0x500(%0); cache %1, 0x540(%0);			cache %1, 0x580(%0); cache %1, 0x5c0(%0);			cache %1, 0x600(%0); cache %1, 0x640(%0);			cache %1, 0x680(%0); cache %1, 0x6c0(%0);			cache %1, 0x700(%0); cache %1, 0x740(%0);			cache %1, 0x780(%0); cache %1, 0x7c0(%0);			.set mips0;							.set reorder\\" : : \\"r\\" ($base), \\"i\\" ($op)););
    }' unless defined(&cache64_unroll32);
    eval 'sub cache128_unroll32 {
        local($base,$op) = @_;
	    eval q( &__asm__  &__volatile__(\\"							.set noreorder;							.set mips3;							cache %1, 0x000(%0); cache %1, 0x080(%0);			cache %1, 0x100(%0); cache %1, 0x180(%0);			cache %1, 0x200(%0); cache %1, 0x280(%0);			cache %1, 0x300(%0); cache %1, 0x380(%0);			cache %1, 0x400(%0); cache %1, 0x480(%0);			cache %1, 0x500(%0); cache %1, 0x580(%0);			cache %1, 0x600(%0); cache %1, 0x680(%0);			cache %1, 0x700(%0); cache %1, 0x780(%0);			cache %1, 0x800(%0); cache %1, 0x880(%0);			cache %1, 0x900(%0); cache %1, 0x980(%0);			cache %1, 0xa00(%0); cache %1, 0xa80(%0);			cache %1, 0xb00(%0); cache %1, 0xb80(%0);			cache %1, 0xc00(%0); cache %1, 0xc80(%0);			cache %1, 0xd00(%0); cache %1, 0xd80(%0);			cache %1, 0xe00(%0); cache %1, 0xe80(%0);			cache %1, 0xf00(%0); cache %1, 0xf80(%0);			.set mips0;							.set reorder\\" : : \\"r\\" ($base), \\"i\\" ($op)););
    }' unless defined(&cache128_unroll32);
}
1;
