require '_h2ph_pre.ph';

unless(defined(&__ASM_MIPS_SIGNAL_H)) {
    eval 'sub __ASM_MIPS_SIGNAL_H () {1;}' unless defined(&__ASM_MIPS_SIGNAL_H);
    require 'linux/types.ph';
    eval 'sub _NSIG () {128;}' unless defined(&_NSIG);
    eval 'sub _NSIG_BPW () {32;}' unless defined(&_NSIG_BPW);
    eval 'sub _NSIG_WORDS () {( &_NSIG /  &_NSIG_BPW);}' unless defined(&_NSIG_WORDS);
    eval 'sub SIGHUP () {1;}' unless defined(&SIGHUP);
    eval 'sub SIGINT () {2;}' unless defined(&SIGINT);
    eval 'sub SIGQUIT () {3;}' unless defined(&SIGQUIT);
    eval 'sub SIGILL () {4;}' unless defined(&SIGILL);
    eval 'sub SIGTRAP () {5;}' unless defined(&SIGTRAP);
    eval 'sub SIGIOT () {6;}' unless defined(&SIGIOT);
    eval 'sub SIGABRT () { &SIGIOT;}' unless defined(&SIGABRT);
    eval 'sub SIGEMT () {7;}' unless defined(&SIGEMT);
    eval 'sub SIGFPE () {8;}' unless defined(&SIGFPE);
    eval 'sub SIGKILL () {9;}' unless defined(&SIGKILL);
    eval 'sub SIGBUS () {10;}' unless defined(&SIGBUS);
    eval 'sub SIGSEGV () {11;}' unless defined(&SIGSEGV);
    eval 'sub SIGSYS () {12;}' unless defined(&SIGSYS);
    eval 'sub SIGPIPE () {13;}' unless defined(&SIGPIPE);
    eval 'sub SIGALRM () {14;}' unless defined(&SIGALRM);
    eval 'sub SIGTERM () {15;}' unless defined(&SIGTERM);
    eval 'sub SIGUSR1 () {16;}' unless defined(&SIGUSR1);
    eval 'sub SIGUSR2 () {17;}' unless defined(&SIGUSR2);
    eval 'sub SIGCHLD () {18;}' unless defined(&SIGCHLD);
    eval 'sub SIGCLD () { &SIGCHLD;}' unless defined(&SIGCLD);
    eval 'sub SIGPWR () {19;}' unless defined(&SIGPWR);
    eval 'sub SIGWINCH () {20;}' unless defined(&SIGWINCH);
    eval 'sub SIGURG () {21;}' unless defined(&SIGURG);
    eval 'sub SIGIO () {22;}' unless defined(&SIGIO);
    eval 'sub SIGPOLL () { &SIGIO;}' unless defined(&SIGPOLL);
    eval 'sub SIGSTOP () {23;}' unless defined(&SIGSTOP);
    eval 'sub SIGTSTP () {24;}' unless defined(&SIGTSTP);
    eval 'sub SIGCONT () {25;}' unless defined(&SIGCONT);
    eval 'sub SIGTTIN () {26;}' unless defined(&SIGTTIN);
    eval 'sub SIGTTOU () {27;}' unless defined(&SIGTTOU);
    eval 'sub SIGVTALRM () {28;}' unless defined(&SIGVTALRM);
    eval 'sub SIGPROF () {29;}' unless defined(&SIGPROF);
    eval 'sub SIGXCPU () {30;}' unless defined(&SIGXCPU);
    eval 'sub SIGXFSZ () {31;}' unless defined(&SIGXFSZ);
    eval 'sub SIGRTMIN () {32;}' unless defined(&SIGRTMIN);
    eval 'sub SIGRTMAX () {( &_NSIG-1);}' unless defined(&SIGRTMAX);
    eval 'sub SA_STACK () {0x00000001;}' unless defined(&SA_STACK);
    eval 'sub SA_RESETHAND () {0x00000002;}' unless defined(&SA_RESETHAND);
    eval 'sub SA_RESTART () {0x00000004;}' unless defined(&SA_RESTART);
    eval 'sub SA_SIGINFO () {0x00000008;}' unless defined(&SA_SIGINFO);
    eval 'sub SA_NODEFER () {0x00000010;}' unless defined(&SA_NODEFER);
    eval 'sub SA_NOCLDWAIT () {0x00010000;}' unless defined(&SA_NOCLDWAIT);
    eval 'sub SA_NOCLDSTOP () {0x00020000;}' unless defined(&SA_NOCLDSTOP);
    eval 'sub SA_NOMASK () { &SA_NODEFER;}' unless defined(&SA_NOMASK);
    eval 'sub SA_ONESHOT () { &SA_RESETHAND;}' unless defined(&SA_ONESHOT);
    eval 'sub SS_ONSTACK () {1;}' unless defined(&SS_ONSTACK);
    eval 'sub SS_DISABLE () {2;}' unless defined(&SS_DISABLE);
    eval 'sub MINSIGSTKSZ () {2048;}' unless defined(&MINSIGSTKSZ);
    eval 'sub SIGSTKSZ () {8192;}' unless defined(&SIGSTKSZ);
    if(defined(&__KERNEL__)) {
	eval 'sub SA_INTERRUPT () {0x01000000;}' unless defined(&SA_INTERRUPT);
	eval 'sub SA_SHIRQ () {0x08000000;}' unless defined(&SA_SHIRQ);
	eval 'sub SA_PROBE () { &SA_ONESHOT;}' unless defined(&SA_PROBE);
	eval 'sub SA_SAMPLE_RANDOM () { &SA_RESTART;}' unless defined(&SA_SAMPLE_RANDOM);
    }
    eval 'sub SIG_BLOCK () {1;}' unless defined(&SIG_BLOCK);
    eval 'sub SIG_UNBLOCK () {2;}' unless defined(&SIG_UNBLOCK);
    eval 'sub SIG_SETMASK () {3;}' unless defined(&SIG_SETMASK);
    eval 'sub SIG_SETMASK32 () {256;}' unless defined(&SIG_SETMASK32);
    eval 'sub SIG_DFL () {(0);}' unless defined(&SIG_DFL);
    eval 'sub SIG_IGN () {(1);}' unless defined(&SIG_IGN);
    eval 'sub SIG_ERR () {(( &__sighandler_t)-1);}' unless defined(&SIG_ERR);
    if(defined(&__KERNEL__)) {
	require 'asm/sigcontext.ph';
    }
    if(defined ( &__KERNEL__) || defined ( &__USE_MISC)) {
	eval 'sub BRK_USERBP () {0;}' unless defined(&BRK_USERBP);
	eval 'sub BRK_KERNELBP () {1;}' unless defined(&BRK_KERNELBP);
	eval 'sub BRK_ABORT () {2;}' unless defined(&BRK_ABORT);
	eval 'sub BRK_BD_TAKEN () {3;}' unless defined(&BRK_BD_TAKEN);
	eval 'sub BRK_BD_NOTTAKEN () {4;}' unless defined(&BRK_BD_NOTTAKEN);
	eval 'sub BRK_SSTEPBP () {5;}' unless defined(&BRK_SSTEPBP);
	eval 'sub BRK_OVERFLOW () {6;}' unless defined(&BRK_OVERFLOW);
	eval 'sub BRK_DIVZERO () {7;}' unless defined(&BRK_DIVZERO);
	eval 'sub BRK_RANGE () {8;}' unless defined(&BRK_RANGE);
	eval 'sub BRK_STACKOVERFLOW () {9;}' unless defined(&BRK_STACKOVERFLOW);
	eval 'sub BRK_NORLD () {10;}' unless defined(&BRK_NORLD);
	eval 'sub _BRK_THREADBP () {11;}' unless defined(&_BRK_THREADBP);
	eval 'sub BRK_MULOVF () {1023;}' unless defined(&BRK_MULOVF);
    }
}
1;
