require '_h2ph_pre.ph';

unless(defined(&__ASM_MIPS_SNI_H)) {
    eval 'sub __ASM_MIPS_SNI_H () {1;}' unless defined(&__ASM_MIPS_SNI_H);
    eval 'sub SNI_PORT_BASE () {0xb4000000;}' unless defined(&SNI_PORT_BASE);
    unless(defined(&__MIPSEL__)) {
	die("Fix me for big endian");
    }
    eval 'sub PCIMT_UCONF () {0xbfff0000;}' unless defined(&PCIMT_UCONF);
    eval 'sub PCIMT_IOADTIMEOUT2 () {0xbfff0008;}' unless defined(&PCIMT_IOADTIMEOUT2);
    eval 'sub PCIMT_IOMEMCONF () {0xbfff0010;}' unless defined(&PCIMT_IOMEMCONF);
    eval 'sub PCIMT_IOMMU () {0xbfff0018;}' unless defined(&PCIMT_IOMMU);
    eval 'sub PCIMT_IOADTIMEOUT1 () {0xbfff0020;}' unless defined(&PCIMT_IOADTIMEOUT1);
    eval 'sub PCIMT_DMAACCESS () {0xbfff0028;}' unless defined(&PCIMT_DMAACCESS);
    eval 'sub PCIMT_DMAHIT () {0xbfff0030;}' unless defined(&PCIMT_DMAHIT);
    eval 'sub PCIMT_ERRSTATUS () {0xbfff0038;}' unless defined(&PCIMT_ERRSTATUS);
    eval 'sub PCIMT_ERRADDR () {0xbfff0040;}' unless defined(&PCIMT_ERRADDR);
    eval 'sub PCIMT_SYNDROME () {0xbfff0048;}' unless defined(&PCIMT_SYNDROME);
    eval 'sub PCIMT_ITPEND () {0xbfff0050;}' unless defined(&PCIMT_ITPEND);
    eval 'sub PCIMT_IRQSEL () {0xbfff0058;}' unless defined(&PCIMT_IRQSEL);
    eval 'sub PCIMT_TESTMEM () {0xbfff0060;}' unless defined(&PCIMT_TESTMEM);
    eval 'sub PCIMT_ECCREG () {0xbfff0068;}' unless defined(&PCIMT_ECCREG);
    eval 'sub PCIMT_CONFIG_ADDRESS () {0xbfff0070;}' unless defined(&PCIMT_CONFIG_ADDRESS);
    eval 'sub PCIMT_ASIC_ID () {0xbfff0078;}' unless defined(&PCIMT_ASIC_ID);
    eval 'sub PCIMT_SOFT_RESET () {0xbfff0078;}' unless defined(&PCIMT_SOFT_RESET);
    eval 'sub PCIMT_PIA_OE () {0xbfff0080;}' unless defined(&PCIMT_PIA_OE);
    eval 'sub PCIMT_PIA_DATAOUT () {0xbfff0088;}' unless defined(&PCIMT_PIA_DATAOUT);
    eval 'sub PCIMT_PIA_DATAIN () {0xbfff0090;}' unless defined(&PCIMT_PIA_DATAIN);
    eval 'sub PCIMT_CACHECONF () {0xbfff0098;}' unless defined(&PCIMT_CACHECONF);
    eval 'sub PCIMT_INVSPACE () {0xbfff00a0;}' unless defined(&PCIMT_INVSPACE);
    eval 'sub PCIMT_PCI_CONF () {0xbfff0100;}' unless defined(&PCIMT_PCI_CONF);
    eval 'sub PCIMT_CONFIG_DATA () {0xb4000cfc;}' unless defined(&PCIMT_CONFIG_DATA);
    eval 'sub PCIMT_CSMSR () {0xbfd00000;}' unless defined(&PCIMT_CSMSR);
    eval 'sub PCIMT_CSSWITCH () {0xbfd10000;}' unless defined(&PCIMT_CSSWITCH);
    eval 'sub PCIMT_CSITPEND () {0xbfd20000;}' unless defined(&PCIMT_CSITPEND);
    eval 'sub PCIMT_AUTO_PO_EN () {0xbfd30000;}' unless defined(&PCIMT_AUTO_PO_EN);
    eval 'sub PCIMT_CLR_TEMP () {0xbfd40000;}' unless defined(&PCIMT_CLR_TEMP);
    eval 'sub PCIMT_AUTO_PO_DIS () {0xbfd50000;}' unless defined(&PCIMT_AUTO_PO_DIS);
    eval 'sub PCIMT_EXMSR () {0xbfd60000;}' unless defined(&PCIMT_EXMSR);
    eval 'sub PCIMT_UNUSED1 () {0xbfd70000;}' unless defined(&PCIMT_UNUSED1);
    eval 'sub PCIMT_CSWCSM () {0xbfd80000;}' unless defined(&PCIMT_CSWCSM);
    eval 'sub PCIMT_UNUSED2 () {0xbfd90000;}' unless defined(&PCIMT_UNUSED2);
    eval 'sub PCIMT_CSLED () {0xbfda0000;}' unless defined(&PCIMT_CSLED);
    eval 'sub PCIMT_CSMAPISA () {0xbfdb0000;}' unless defined(&PCIMT_CSMAPISA);
    eval 'sub PCIMT_CSRSTBP () {0xbfdc0000;}' unless defined(&PCIMT_CSRSTBP);
    eval 'sub PCIMT_CLRPOFF () {0xbfdd0000;}' unless defined(&PCIMT_CLRPOFF);
    eval 'sub PCIMT_CSTIMER () {0xbfde0000;}' unless defined(&PCIMT_CSTIMER);
    eval 'sub PCIMT_PWDN () {0xbfdf0000;}' unless defined(&PCIMT_PWDN);
    eval 'sub PCIMT_KEYBOARD_IRQ () {1;}' unless defined(&PCIMT_KEYBOARD_IRQ);
    eval 'sub PCIMT_IRQ_ETHERNET () {16;}' unless defined(&PCIMT_IRQ_ETHERNET);
    eval 'sub PCIMT_IRQ_TEMPERATURE () {17;}' unless defined(&PCIMT_IRQ_TEMPERATURE);
    eval 'sub PCIMT_IRQ_EISA_NMI () {18;}' unless defined(&PCIMT_IRQ_EISA_NMI);
    eval 'sub PCIMT_IRQ_POWER_OFF () {19;}' unless defined(&PCIMT_IRQ_POWER_OFF);
    eval 'sub PCIMT_IRQ_BUTTON () {20;}' unless defined(&PCIMT_IRQ_BUTTON);
    eval 'sub PCIMT_IRQ_INTA () {21;}' unless defined(&PCIMT_IRQ_INTA);
    eval 'sub PCIMT_IRQ_INTB () {22;}' unless defined(&PCIMT_IRQ_INTB);
    eval 'sub PCIMT_IRQ_INTC () {23;}' unless defined(&PCIMT_IRQ_INTC);
    eval 'sub PCIMT_IRQ_INTD () {24;}' unless defined(&PCIMT_IRQ_INTD);
    eval 'sub PCIMT_IRQ_SCSI () {25;}' unless defined(&PCIMT_IRQ_SCSI);
    eval 'sub PCIMT_EISA_BASE () {0xb0000000;}' unless defined(&PCIMT_EISA_BASE);
    eval 'sub PCIMT_INT_ACKNOWLEDGE () {0xba000000;}' unless defined(&PCIMT_INT_ACKNOWLEDGE);
}
1;
