require '_h2ph_pre.ph';

unless(defined(&__ASM_MIPS_SPINLOCK_H)) {
    eval 'sub __ASM_MIPS_SPINLOCK_H () {1;}' unless defined(&__ASM_MIPS_SPINLOCK_H);
    unless(defined(&__SMP__)) {
	if(((defined(&__GNUC__) ? &__GNUC__ : 0) > 2) || ((defined(&__GNUC__) ? &__GNUC__ : 0) == 2 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) >= 8)) {
	    eval 'sub SPIN_LOCK_UNLOCKED () {{ };}' unless defined(&SPIN_LOCK_UNLOCKED);
	} else {
	    eval 'sub SPIN_LOCK_UNLOCKED () {{ 0};}' unless defined(&SPIN_LOCK_UNLOCKED);
	}
	eval 'sub spin_lock_init {
	    local($lock) = @_;
    	    eval q( &do { }  &while(0));
	}' unless defined(&spin_lock_init);
	eval 'sub spin_lock {
	    local($lock) = @_;
    	    eval q( &do { }  &while(0));
	}' unless defined(&spin_lock);
	eval 'sub spin_trylock {
	    local($lock) = @_;
    	    eval q((1));
	}' unless defined(&spin_trylock);
	eval 'sub spin_unlock_wait {
	    local($lock) = @_;
    	    eval q( &do { }  &while(0));
	}' unless defined(&spin_unlock_wait);
	eval 'sub spin_unlock {
	    local($lock) = @_;
    	    eval q( &do { }  &while(0));
	}' unless defined(&spin_unlock);
	eval 'sub spin_lock_irq {
	    local($lock) = @_;
    	    eval q( &cli());
	}' unless defined(&spin_lock_irq);
	eval 'sub spin_unlock_irq {
	    local($lock) = @_;
    	    eval q( &sti());
	}' unless defined(&spin_unlock_irq);
	eval 'sub spin_lock_irqsave {
	    local($lock, $flags) = @_;
    	    eval q( &save_and_cli($flags));
	}' unless defined(&spin_lock_irqsave);
	eval 'sub spin_unlock_irqrestore {
	    local($lock, $flags) = @_;
    	    eval q( &restore_flags($flags));
	}' unless defined(&spin_unlock_irqrestore);
	eval 'sub RW_LOCK_UNLOCKED () {{ };}' unless defined(&RW_LOCK_UNLOCKED);
	eval 'sub read_lock {
	    local($lock) = @_;
    	    eval q( &do { }  &while(0));
	}' unless defined(&read_lock);
	eval 'sub read_unlock {
	    local($lock) = @_;
    	    eval q( &do { }  &while(0));
	}' unless defined(&read_unlock);
	eval 'sub write_lock {
	    local($lock) = @_;
    	    eval q( &do { }  &while(0));
	}' unless defined(&write_lock);
	eval 'sub write_unlock {
	    local($lock) = @_;
    	    eval q( &do { }  &while(0));
	}' unless defined(&write_unlock);
	eval 'sub read_lock_irq {
	    local($lock) = @_;
    	    eval q( &cli());
	}' unless defined(&read_lock_irq);
	eval 'sub read_unlock_irq {
	    local($lock) = @_;
    	    eval q( &sti());
	}' unless defined(&read_unlock_irq);
	eval 'sub write_lock_irq {
	    local($lock) = @_;
    	    eval q( &cli());
	}' unless defined(&write_lock_irq);
	eval 'sub write_unlock_irq {
	    local($lock) = @_;
    	    eval q( &sti());
	}' unless defined(&write_unlock_irq);
	eval 'sub read_lock_irqsave {
	    local($lock, $flags) = @_;
    	    eval q( &save_and_cli($flags));
	}' unless defined(&read_lock_irqsave);
	eval 'sub read_unlock_irqrestore {
	    local($lock, $flags) = @_;
    	    eval q( &restore_flags($flags));
	}' unless defined(&read_unlock_irqrestore);
	eval 'sub write_lock_irqsave {
	    local($lock, $flags) = @_;
    	    eval q( &save_and_cli($flags));
	}' unless defined(&write_lock_irqsave);
	eval 'sub write_unlock_irqrestore {
	    local($lock, $flags) = @_;
    	    eval q( &restore_flags($flags));
	}' unless defined(&write_unlock_irqrestore);
    } else {
	die("Nix SMP on MIPS");
    }
}
1;
