require '_h2ph_pre.ph';

unless(defined(&_MATH_H)) {
    eval 'sub _MATH_H () {1;}' unless defined(&_MATH_H);
    require 'features.ph';
    require 'huge_val.ph';
    if(defined(&__USE_GNU)) {
	require 'nan.ph';
    }
    eval 'sub __MATHCALL {
        local($function,$suffix, $args) = @_;
	    eval q( &__MATHDECL ( &_Mdouble_,$function,$suffix, $args));
    }' unless defined(&__MATHCALL);
    eval 'sub __MATHDECL {
        local($type, $function,$suffix, $args) = @_;
	    eval q( &__MATHDECL_1($type, $function,$suffix, $args);  &__MATHDECL_1($type,  &__CONCAT( &__,$function),$suffix, $args));
    }' unless defined(&__MATHDECL);
    eval 'sub __MATHDECL_1 {
        local($type, $function,$suffix, $args) = @_;
	    eval q( &extern $type  &__MATH_PRECNAME($function,$suffix) $args);
    }' unless defined(&__MATHDECL_1);
    eval 'sub _Mdouble_ () { &double;}' unless defined(&_Mdouble_);
    eval 'sub __MATH_PRECNAME {
        local($name,$r) = @_;
	    eval q( &__CONCAT($name,$r));
    }' unless defined(&__MATH_PRECNAME);
    require 'mathcalls.ph';
    undef(&_Mdouble_) if defined(&_Mdouble_);
    undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
    if(defined(&__USE_MISC)) {
	unless(defined(&_Mfloat_)) {
	    eval 'sub _Mfloat_ () { &float;}' unless defined(&_Mfloat_);
	}
	eval 'sub _Mdouble_ () { &_Mfloat_;}' unless defined(&_Mdouble_);
	if(defined(&__STDC__)) {
	    eval 'sub __MATH_PRECNAME {
	        local($name,$r) = @_;
    		eval q($name &f$r);
	    }' unless defined(&__MATH_PRECNAME);
	} else {
	    eval 'sub __MATH_PRECNAME {
	        local($name,$r) = @_;
    		eval q( &namefr);
	    }' unless defined(&__MATH_PRECNAME);
	}
	require 'mathcalls.ph';
	undef(&_Mdouble_) if defined(&_Mdouble_);
	undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
	unless(defined(&_Mlong_double_)) {
	    eval 'sub _Mlong_double_ () {\'long double\';}' unless defined(&_Mlong_double_);
	}
	eval 'sub _Mdouble_ () {\'_Mlong_double_\';}' unless defined(&_Mdouble_);
	if(defined(&__STDC__)) {
	    eval 'sub __MATH_PRECNAME {
	        local($name,$r) = @_;
    		eval q($name &l$r);
	    }' unless defined(&__MATH_PRECNAME);
	} else {
	    eval 'sub __MATH_PRECNAME {
	        local($name,$r) = @_;
    		eval q( &namelr);
	    }' unless defined(&__MATH_PRECNAME);
	}
	require 'mathcalls.ph';
	undef(&_Mdouble_) if defined(&_Mdouble_);
	undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
    }
    if(defined (defined(&__USE_MISC) ? &__USE_MISC : 0) || defined (defined(&__USE_XOPEN) ? &__USE_XOPEN : 0) || defined (defined(&__USE_ISOC9X) ? &__USE_ISOC9X : 0)) {
    }
    if(defined(&__USE_MISC)) {
	eval("sub _IEEE_ () { -1; }") unless defined(&_IEEE_);
	eval("sub _SVID_ () { 0; }") unless defined(&_SVID_);
	eval("sub _XOPEN_ () { 1; }") unless defined(&_XOPEN_);
	eval("sub _POSIX_ () { 2; }") unless defined(&_POSIX_);
    }
    if(defined(&__USE_SVID)) {
	if(defined(&__cplusplus)) {
	} else {
	}
	if(defined(&__cplusplus)) {
	} else {
	}
	eval 'sub X_TLOSS () {1.41484755040568800000e+16;}' unless defined(&X_TLOSS);
	eval 'sub DOMAIN () {1;}' unless defined(&DOMAIN);
	eval 'sub SING () {2;}' unless defined(&SING);
	eval 'sub OVERFLOW () {3;}' unless defined(&OVERFLOW);
	eval 'sub UNDERFLOW () {4;}' unless defined(&UNDERFLOW);
	eval 'sub TLOSS () {5;}' unless defined(&TLOSS);
	eval 'sub PLOSS () {6;}' unless defined(&PLOSS);
	eval 'sub HUGE () { &FLT_MAX;}' unless defined(&HUGE);
	require 'float.ph';
    } else {
	if(defined(&__USE_XOPEN)) {
	    eval 'sub MAXFLOAT () { &FLT_MAX;}' unless defined(&MAXFLOAT);
	    require 'float.ph';
	}
    }
    if(defined(&__USE_BSD)) {
	eval 'sub M_E () { &_Mldbl(2.7182818284590452354);}' unless defined(&M_E);
	eval 'sub M_LOG2E () { &_Mldbl(1.4426950408889634074);}' unless defined(&M_LOG2E);
	eval 'sub M_LOG10E () { &_Mldbl(0.43429448190325182765);}' unless defined(&M_LOG10E);
	eval 'sub M_LN2 () { &_Mldbl(0.69314718055994530942);}' unless defined(&M_LN2);
	eval 'sub M_LN10 () { &_Mldbl(2.30258509299404568402);}' unless defined(&M_LN10);
	eval 'sub M_PI () { &_Mldbl(3.14159265358979323846);}' unless defined(&M_PI);
	eval 'sub M_PI_2 () { &_Mldbl(1.57079632679489661923);}' unless defined(&M_PI_2);
	eval 'sub M_PI_4 () { &_Mldbl(0.78539816339744830962);}' unless defined(&M_PI_4);
	eval 'sub M_1_PI () { &_Mldbl(0.31830988618379067154);}' unless defined(&M_1_PI);
	eval 'sub M_2_PI () { &_Mldbl(0.63661977236758134308);}' unless defined(&M_2_PI);
	eval 'sub M_2_SQRTPI () { &_Mldbl(1.12837916709551257390);}' unless defined(&M_2_SQRTPI);
	eval 'sub M_SQRT2 () { &_Mldbl(1.41421356237309504880);}' unless defined(&M_SQRT2);
	eval 'sub M_SQRT1_2 () { &_Mldbl(0.70710678118654752440);}' unless defined(&M_SQRT1_2);
    }
    if((defined(&__STDC__) ? &__STDC__ : 0) - 0|| (defined(&__GNUC__) ? &__GNUC__ : 0) - 0) {
	eval 'sub _Mldbl {
	    local($x) = @_;
    	    eval q($x &L);
	}' unless defined(&_Mldbl);
    } else {
	eval 'sub _Mldbl {
	    local($x) = @_;
    	    eval q($x);
	}' unless defined(&_Mldbl);
    }
    if((!defined (defined(&__NO_MATH_INLINES) ? &__NO_MATH_INLINES : 0)  && defined (defined(&__OPTIMIZE__) ? &__OPTIMIZE__ : 0)) || defined (defined(&__LIBC_M81_MATH_INLINES) ? &__LIBC_M81_MATH_INLINES : 0)) {
	require '__math.ph';
    }
}
1;
