require '_h2ph_pre.ph';

unless(defined(&_WCTYPE_H)) {
    eval 'sub _WCTYPE_H () {1;}' unless defined(&_WCTYPE_H);
    require 'features.ph';
    eval 'sub __need_wint_t () {1;}' unless defined(&__need_wint_t);
    require 'stddef.ph';
    unless(defined(&_WINT_T)) {
	eval 'sub _WINT_T () {1;}' unless defined(&_WINT_T);
    }
    unless(defined(&WEOF)) {
	eval 'sub WEOF () {(0xffffffff);}' unless defined(&WEOF);
    }
    unless(defined(&_ISbit)) {
	require 'endian.ph';
	if((defined(&__BYTE_ORDER) ? &__BYTE_ORDER : 0) == (defined(&__BIG_ENDIAN) ? &__BIG_ENDIAN : 0)) {
	    eval 'sub _ISbit {
	        local($bit) = @_;
    		eval q((1<< $bit));
	    }' unless defined(&_ISbit);
	} else {
	    eval 'sub _ISbit {
	        local($bit) = @_;
    		eval q(($bit < 8? ((1<< $bit) << 8) : ((1<< $bit) >> 8)));
	    }' unless defined(&_ISbit);
	}
    }
    unless(defined(&__NO_WCTYPE)) {
	eval 'sub iswalnum {
	    local($wc) = @_;
    	    eval q( &__iswctype (($wc),  &_ISalnum));
	}' unless defined(&iswalnum);
	eval 'sub iswalpha {
	    local($wc) = @_;
    	    eval q( &__iswctype (($wc),  &_ISalpha));
	}' unless defined(&iswalpha);
	eval 'sub iswcntrl {
	    local($wc) = @_;
    	    eval q( &__iswctype (($wc),  &_IScntrl));
	}' unless defined(&iswcntrl);
	eval 'sub iswdigit {
	    local($wc) = @_;
    	    eval q( &__iswctype (($wc),  &_ISdigit));
	}' unless defined(&iswdigit);
	eval 'sub iswlower {
	    local($wc) = @_;
    	    eval q( &__iswctype (($wc),  &_ISlower));
	}' unless defined(&iswlower);
	eval 'sub iswgraph {
	    local($wc) = @_;
    	    eval q( &__iswctype (($wc),  &_ISgraph));
	}' unless defined(&iswgraph);
	eval 'sub iswprint {
	    local($wc) = @_;
    	    eval q( &__iswctype (($wc),  &_ISprint));
	}' unless defined(&iswprint);
	eval 'sub iswpunct {
	    local($wc) = @_;
    	    eval q( &__iswctype (($wc),  &_ISpunct));
	}' unless defined(&iswpunct);
	eval 'sub iswspace {
	    local($wc) = @_;
    	    eval q( &__iswctype (($wc),  &_ISspace));
	}' unless defined(&iswspace);
	eval 'sub iswupper {
	    local($wc) = @_;
    	    eval q( &__iswctype (($wc),  &_ISupper));
	}' unless defined(&iswupper);
	eval 'sub iswxdigit {
	    local($wc) = @_;
    	    eval q( &__iswctype (($wc),  &_ISxdigit));
	}' unless defined(&iswxdigit);
	if(defined(&__USE_GNU)) {
	    eval 'sub iswblank {
	        local($wc) = @_;
    		eval q( &__iswctype (($wc),  &_ISblank));
	    }' unless defined(&iswblank);
	}
	eval 'sub towlower {
	    local($wc) = @_;
    	    eval q( &towctrans ($wc,  &__ctype_tolower));
	}' unless defined(&towlower);
	eval 'sub towupper {
	    local($wc) = @_;
    	    eval q( &towctrans ($wc,  &__ctype_toupper));
	}' unless defined(&towupper);
    }
}
1;
